import { isArray } from 'rxjs/internal-compatibility';
import { FaIconComponent, FontAwesomeModule } from '@fortawesome/angular-fontawesome';
import { __decorate, __metadata } from 'tslib';
import { moveItemInArray, DragDropModule } from '@angular/cdk/drag-drop';
import { filter, map, takeUntil, withLatestFrom, share, delay } from 'rxjs/operators';
import { library } from '@fortawesome/fontawesome-svg-core';
import { fas } from '@fortawesome/free-solid-svg-icons';
import { NG_VALUE_ACCESSOR, NgControl, FormsModule, ReactiveFormsModule } from '@angular/forms';
import { animate, state, style, transition, trigger } from '@angular/animations';
import { DomSanitizer } from '@angular/platform-browser';
import { DOCUMENT, CommonModule } from '@angular/common';
import { Component, Injectable, Input, EventEmitter, Output, Injector, ComponentFactoryResolver, NgModule, Inject, ElementRef, forwardRef, ViewChild, ContentChildren, Directive, TemplateRef, InjectionToken, NgZone, SecurityContext, ChangeDetectionStrategy, Renderer2, ViewContainerRef, ViewEncapsulation, ChangeDetectorRef, ApplicationRef, defineInjectable, inject, INJECTOR, RendererFactory2, HostBinding, HostListener, ContentChild } from '@angular/core';
import { fromEvent, Subject, Observable, merge, race } from 'rxjs';

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,uselessCode} checked by tsc
 */
class IconComponent extends FaIconComponent {
}
IconComponent.decorators = [
    { type: Component, args: [{
                selector: 'icon',
                template: ``,
                host: {
                    class: 'ng-fa-icon',
                    '[attr.title]': 'title',
                }
            }] }
];

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,uselessCode} checked by tsc
 */
/**
 * A configuration service for the [`NgbModal`](#/components/modal/api#NgbModal) service.
 *
 * You can inject this service, typically in your root component, and customize the values of its properties in
 * order to provide default values for all modals used in the application.
 *
 * \@since 3.1.0
 */
class NgbModalConfig {
    constructor() {
        this.backdrop = true;
        this.keyboard = true;
    }
}
NgbModalConfig.decorators = [
    { type: Injectable, args: [{ providedIn: 'root' },] }
];
/** @nocollapse */ NgbModalConfig.ngInjectableDef = defineInjectable({ factory: function NgbModalConfig_Factory() { return new NgbModalConfig(); }, token: NgbModalConfig, providedIn: "root" });

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,uselessCode} checked by tsc
 */
/** @enum {number} */
const Key = {
    Tab: 9,
    Enter: 13,
    Escape: 27,
    Space: 32,
    PageUp: 33,
    PageDown: 34,
    End: 35,
    Home: 36,
    ArrowLeft: 37,
    ArrowUp: 38,
    ArrowRight: 39,
    ArrowDown: 40,
};
Key[Key.Tab] = 'Tab';
Key[Key.Enter] = 'Enter';
Key[Key.Escape] = 'Escape';
Key[Key.Space] = 'Space';
Key[Key.PageUp] = 'PageUp';
Key[Key.PageDown] = 'PageDown';
Key[Key.End] = 'End';
Key[Key.Home] = 'Home';
Key[Key.ArrowLeft] = 'ArrowLeft';
Key[Key.ArrowUp] = 'ArrowUp';
Key[Key.ArrowRight] = 'ArrowRight';
Key[Key.ArrowDown] = 'ArrowDown';

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,uselessCode} checked by tsc
 */
/** @type {?} */
const FOCUSABLE_ELEMENTS_SELECTOR = [
    'a[href]', 'button:not([disabled])', 'input:not([disabled]):not([type="hidden"])', 'select:not([disabled])',
    'textarea:not([disabled])', '[contenteditable]', '[tabindex]:not([tabindex="-1"])'
].join(', ');
/**
 * Returns first and last focusable elements inside of a given element based on specific CSS selector
 * @param {?} element
 * @return {?}
 */
function getFocusableBoundaryElements(element) {
    /** @type {?} */
    const list = Array.from((/** @type {?} */ (element.querySelectorAll(FOCUSABLE_ELEMENTS_SELECTOR))))
        .filter(el => el.tabIndex !== -1);
    return [list[0], list[list.length - 1]];
}
/**
 * Function that enforces browser focus to be trapped inside a DOM element.
 *
 * Works only for clicks inside the element and navigation with 'Tab', ignoring clicks outside of the element
 *
 * \@param element The element around which focus will be trapped inside
 * \@param stopFocusTrap$ The observable stream. When completed the focus trap will clean up listeners
 * and free internal resources
 * \@param refocusOnClick Put the focus back to the last focused element whenever a click occurs on element (default to
 * false)
 * @type {?}
 */
const FocusTrap = (element, stopFocusTrap$, refocusOnClick = false) => {
    // last focused element
    /** @type {?} */
    const lastFocusedElement$ = fromEvent(element, 'focusin').pipe(takeUntil(stopFocusTrap$), map(e => e.target));
    // 'tab' / 'shift+tab' stream
    fromEvent(element, 'keydown')
        .pipe(takeUntil(stopFocusTrap$), 
    // tslint:disable:deprecation
    filter(e => e.which === Key.Tab), 
    // tslint:enable:deprecation
    withLatestFrom(lastFocusedElement$))
        .subscribe(([tabEvent, focusedElement]) => {
        const [first, last] = getFocusableBoundaryElements(element);
        if ((focusedElement === first || focusedElement === element) && tabEvent.shiftKey) {
            last.focus();
            tabEvent.preventDefault();
        }
        if (focusedElement === last && !tabEvent.shiftKey) {
            first.focus();
            tabEvent.preventDefault();
        }
    });
    // inside click
    if (refocusOnClick) {
        fromEvent(element, 'click')
            .pipe(takeUntil(stopFocusTrap$), withLatestFrom(lastFocusedElement$), map(arr => (/** @type {?} */ (arr[1]))))
            .subscribe(lastFocusedElement => lastFocusedElement.focus());
    }
};

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,uselessCode} checked by tsc
 */
class ContentRef {
    /**
     * @param {?} nodes
     * @param {?=} viewRef
     * @param {?=} componentRef
     */
    constructor(nodes, viewRef, componentRef) {
        this.nodes = nodes;
        this.viewRef = viewRef;
        this.componentRef = componentRef;
    }
}
/**
 * @template T
 */
class PopupService {
    /**
     * @param {?} _type
     * @param {?} _injector
     * @param {?} _viewContainerRef
     * @param {?} _renderer
     * @param {?} _componentFactoryResolver
     * @param {?} _applicationRef
     */
    constructor(_type, _injector, _viewContainerRef, _renderer, _componentFactoryResolver, _applicationRef) {
        this._type = _type;
        this._injector = _injector;
        this._viewContainerRef = _viewContainerRef;
        this._renderer = _renderer;
        this._componentFactoryResolver = _componentFactoryResolver;
        this._applicationRef = _applicationRef;
    }
    /**
     * @param {?=} content
     * @param {?=} context
     * @return {?}
     */
    open(content, context) {
        if (!this._windowRef) {
            this._contentRef = this._getContentRef(content, context);
            this._windowRef = this._viewContainerRef.createComponent(this._componentFactoryResolver.resolveComponentFactory(this._type), 0, this._injector, this._contentRef.nodes);
        }
        return this._windowRef;
    }
    /**
     * @return {?}
     */
    close() {
        if (this._windowRef) {
            this._viewContainerRef.remove(this._viewContainerRef.indexOf(this._windowRef.hostView));
            this._windowRef = null;
            if (this._contentRef.viewRef) {
                this._applicationRef.detachView(this._contentRef.viewRef);
                this._contentRef.viewRef.destroy();
                this._contentRef = null;
            }
        }
    }
    /**
     * @param {?} content
     * @param {?=} context
     * @return {?}
     */
    _getContentRef(content, context) {
        if (!content) {
            return new ContentRef([]);
        }
        else if (content instanceof TemplateRef) {
            /** @type {?} */
            const viewRef = content.createEmbeddedView(context);
            this._applicationRef.attachView(viewRef);
            return new ContentRef([viewRef.rootNodes], viewRef);
        }
        else {
            return new ContentRef([[this._renderer.createText(`${content}`)]]);
        }
    }
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,uselessCode} checked by tsc
 */
/** @type {?} */
const noop = () => { };
/**
 * Utility to handle the scrollbar.
 *
 * It allows to compensate the lack of a vertical scrollbar by adding an
 * equivalent padding on the right of the body, and to remove this compensation.
 */
class ScrollBar {
    /**
     * @param {?} _document
     */
    constructor(_document) {
        this._document = _document;
    }
    /**
     * Detects if a scrollbar is present and if yes, already compensates for its
     * removal by adding an equivalent padding on the right of the body.
     *
     * @return {?} a callback used to revert the compensation (noop if there was none,
     * otherwise a function removing the padding)
     */
    compensate() { return !this._isPresent() ? noop : this._adjustBody(this._getWidth()); }
    /**
     * Adds a padding of the given width on the right of the body.
     *
     * @param {?} width
     * @return {?} a callback used to revert the padding to its previous value
     */
    _adjustBody(width) {
        /** @type {?} */
        const body = this._document.body;
        /** @type {?} */
        const userSetPadding = body.style.paddingRight;
        /** @type {?} */
        const paddingAmount = parseFloat(window.getComputedStyle(body)['padding-right']);
        body.style['padding-right'] = `${paddingAmount + width}px`;
        return () => body.style['padding-right'] = userSetPadding;
    }
    /**
     * Tells whether a scrollbar is currently present on the body.
     *
     * @return {?} true if scrollbar is present, false otherwise
     */
    _isPresent() {
        /** @type {?} */
        const rect = this._document.body.getBoundingClientRect();
        return rect.left + rect.right < window.innerWidth;
    }
    /**
     * Calculates and returns the width of a scrollbar.
     *
     * @return {?} the width of a scrollbar on this page
     */
    _getWidth() {
        /** @type {?} */
        const measurer = this._document.createElement('div');
        measurer.className = 'modal-scrollbar-measure';
        /** @type {?} */
        const body = this._document.body;
        body.appendChild(measurer);
        /** @type {?} */
        const width = measurer.getBoundingClientRect().width - measurer.clientWidth;
        body.removeChild(measurer);
        return width;
    }
}
ScrollBar.decorators = [
    { type: Injectable, args: [{ providedIn: 'root' },] }
];
/** @nocollapse */
ScrollBar.ctorParameters = () => [
    { type: undefined, decorators: [{ type: Inject, args: [DOCUMENT,] }] }
];
/** @nocollapse */ ScrollBar.ngInjectableDef = defineInjectable({ factory: function ScrollBar_Factory() { return new ScrollBar(inject(DOCUMENT)); }, token: ScrollBar, providedIn: "root" });

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,uselessCode} checked by tsc
 */
/**
 * @param {?} value
 * @return {?}
 */
function isString(value) {
    return typeof value === 'string';
}
/**
 * @param {?} value
 * @return {?}
 */
function isDefined(value) {
    return value !== undefined && value !== null;
}
if (typeof Element !== 'undefined' && !Element.prototype.closest) {
    // Polyfill for ie10+
    if (!Element.prototype.matches) {
        // IE uses the non-standard name: msMatchesSelector
        Element.prototype.matches = ((/** @type {?} */ (Element.prototype))).msMatchesSelector || Element.prototype.webkitMatchesSelector;
    }
    Element.prototype.closest = function (s) {
        /** @type {?} */
        let el = this;
        if (!document.documentElement.contains(el)) {
            return null;
        }
        do {
            if (el.matches(s)) {
                return el;
            }
            el = el.parentElement || el.parentNode;
        } while (el !== null && el.nodeType === 1);
        return null;
    };
}
/**
 * @param {?} element
 * @param {?} selector
 * @return {?}
 */
function closest(element, selector) {
    if (!selector) {
        return null;
    }
    return element.closest(selector);
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,uselessCode} checked by tsc
 */
class NgbModalBackdrop {
}
NgbModalBackdrop.decorators = [
    { type: Component, args: [{
                selector: 'ngb-modal-backdrop',
                template: '',
                host: { '[class]': '"modal-backdrop fade show" + (backdropClass ? " " + backdropClass : "")', 'style': 'z-index: 1050' }
            }] }
];
NgbModalBackdrop.propDecorators = {
    backdropClass: [{ type: Input }]
};

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,uselessCode} checked by tsc
 */
/**
 * A reference to the currently opened (active) modal.
 *
 * Instances of this class can be injected into your component passed as modal content.
 * So you can `.close()` or `.dismiss()` the modal window from your component.
 */
class NgbActiveModal {
    /**
     * Closes the modal with an optional `result` value.
     *
     * The `NgbMobalRef.result` promise will be resolved with the provided value.
     * @param {?=} result
     * @return {?}
     */
    close(result) { }
    /**
     * Dismisses the modal with an optional `reason` value.
     *
     * The `NgbModalRef.result` promise will be rejected with the provided value.
     * @param {?=} reason
     * @return {?}
     */
    dismiss(reason) { }
}
/**
 * A reference to the newly opened modal returned by the `NgbModal.open()` method.
 */
class NgbModalRef {
    /**
     * @param {?} _windowCmptRef
     * @param {?} _contentRef
     * @param {?=} _backdropCmptRef
     * @param {?=} _beforeDismiss
     */
    constructor(_windowCmptRef, _contentRef, _backdropCmptRef, _beforeDismiss) {
        this._windowCmptRef = _windowCmptRef;
        this._contentRef = _contentRef;
        this._backdropCmptRef = _backdropCmptRef;
        this._beforeDismiss = _beforeDismiss;
        _windowCmptRef.instance.dismissEvent.subscribe((reason) => { this.dismiss(reason); });
        this.result = new Promise((resolve, reject) => {
            this._resolve = resolve;
            this._reject = reject;
        });
        this.result.then(null, () => { });
    }
    /**
     * The instance of a component used for the modal content.
     *
     * When a `TemplateRef` is used as the content, will return `undefined`.
     * @return {?}
     */
    get componentInstance() {
        if (this._contentRef.componentRef) {
            return this._contentRef.componentRef.instance;
        }
    }
    /**
     * Closes the modal with an optional `result` value.
     *
     * The `NgbMobalRef.result` promise will be resolved with the provided value.
     * @param {?=} result
     * @return {?}
     */
    close(result) {
        if (this._windowCmptRef) {
            this._resolve(result);
            this._removeModalElements();
        }
    }
    /**
     * @param {?=} reason
     * @return {?}
     */
    _dismiss(reason) {
        this._reject(reason);
        this._removeModalElements();
    }
    /**
     * Dismisses the modal with an optional `reason` value.
     *
     * The `NgbModalRef.result` promise will be rejected with the provided value.
     * @param {?=} reason
     * @return {?}
     */
    dismiss(reason) {
        if (this._windowCmptRef) {
            if (!this._beforeDismiss) {
                this._dismiss(reason);
            }
            else {
                /** @type {?} */
                const dismiss = this._beforeDismiss();
                if (dismiss && dismiss.then) {
                    dismiss.then(result => {
                        if (result !== false) {
                            this._dismiss(reason);
                        }
                    }, () => { });
                }
                else if (dismiss !== false) {
                    this._dismiss(reason);
                }
            }
        }
    }
    /**
     * @return {?}
     */
    _removeModalElements() {
        /** @type {?} */
        const windowNativeEl = this._windowCmptRef.location.nativeElement;
        windowNativeEl.parentNode.removeChild(windowNativeEl);
        this._windowCmptRef.destroy();
        if (this._backdropCmptRef) {
            /** @type {?} */
            const backdropNativeEl = this._backdropCmptRef.location.nativeElement;
            backdropNativeEl.parentNode.removeChild(backdropNativeEl);
            this._backdropCmptRef.destroy();
        }
        if (this._contentRef && this._contentRef.viewRef) {
            this._contentRef.viewRef.destroy();
        }
        this._windowCmptRef = null;
        this._backdropCmptRef = null;
        this._contentRef = null;
    }
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,uselessCode} checked by tsc
 */
/** @enum {number} */
const ModalDismissReasons = {
    BACKDROP_CLICK: 0,
    ESC: 1,
};
ModalDismissReasons[ModalDismissReasons.BACKDROP_CLICK] = 'BACKDROP_CLICK';
ModalDismissReasons[ModalDismissReasons.ESC] = 'ESC';

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,uselessCode} checked by tsc
 */
class NgbModalWindow {
    /**
     * @param {?} _document
     * @param {?} _elRef
     */
    constructor(_document, _elRef) {
        this._document = _document;
        this._elRef = _elRef;
        this.backdrop = true;
        this.keyboard = true;
        this.dismissEvent = new EventEmitter();
    }
    /**
     * @param {?} $event
     * @return {?}
     */
    backdropClick($event) {
        if (this.backdrop === true && this._elRef.nativeElement === $event.target) {
            this.dismiss(ModalDismissReasons.BACKDROP_CLICK);
        }
    }
    /**
     * @param {?} $event
     * @return {?}
     */
    escKey($event) {
        if (this.keyboard && !$event.defaultPrevented) {
            this.dismiss(ModalDismissReasons.ESC);
        }
    }
    /**
     * @param {?} reason
     * @return {?}
     */
    dismiss(reason) { this.dismissEvent.emit(reason); }
    /**
     * @return {?}
     */
    ngOnInit() { this._elWithFocus = this._document.activeElement; }
    /**
     * @return {?}
     */
    ngAfterViewInit() {
        if (!this._elRef.nativeElement.contains(document.activeElement)) {
            /** @type {?} */
            const autoFocusable = (/** @type {?} */ (this._elRef.nativeElement.querySelector(`[ngbAutofocus]`)));
            /** @type {?} */
            const firstFocusable = getFocusableBoundaryElements(this._elRef.nativeElement)[0];
            /** @type {?} */
            const elementToFocus = autoFocusable || firstFocusable || this._elRef.nativeElement;
            elementToFocus.focus();
        }
    }
    /**
     * @return {?}
     */
    ngOnDestroy() {
        /** @type {?} */
        const body = this._document.body;
        /** @type {?} */
        const elWithFocus = this._elWithFocus;
        /** @type {?} */
        let elementToFocus;
        if (elWithFocus && elWithFocus['focus'] && body.contains(elWithFocus)) {
            elementToFocus = elWithFocus;
        }
        else {
            elementToFocus = body;
        }
        elementToFocus.focus();
        this._elWithFocus = null;
    }
}
NgbModalWindow.decorators = [
    { type: Component, args: [{
                selector: 'ngb-modal-window',
                host: {
                    '[class]': '"modal fade show d-block" + (windowClass ? " " + windowClass : "")',
                    'role': 'dialog',
                    'tabindex': '-1',
                    '(keyup.esc)': 'escKey($event)',
                    '(click)': 'backdropClick($event)',
                    '[attr.aria-modal]': 'true',
                    '[attr.aria-labelledby]': 'ariaLabelledBy',
                },
                template: `
    <div [class]="'modal-dialog' + (size ? ' modal-' + size : '') + (centered ? ' modal-dialog-centered' : '')" role="document">
        <div class="modal-content"><ng-content></ng-content></div>
    </div>
    `
            }] }
];
/** @nocollapse */
NgbModalWindow.ctorParameters = () => [
    { type: undefined, decorators: [{ type: Inject, args: [DOCUMENT,] }] },
    { type: ElementRef }
];
NgbModalWindow.propDecorators = {
    ariaLabelledBy: [{ type: Input }],
    backdrop: [{ type: Input }],
    centered: [{ type: Input }],
    keyboard: [{ type: Input }],
    size: [{ type: Input }],
    windowClass: [{ type: Input }],
    dismissEvent: [{ type: Output, args: ['dismiss',] }]
};

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,uselessCode} checked by tsc
 */
class NgbModalStack {
    /**
     * @param {?} _applicationRef
     * @param {?} _injector
     * @param {?} _document
     * @param {?} _scrollBar
     * @param {?} _rendererFactory
     */
    constructor(_applicationRef, _injector, _document, _scrollBar, _rendererFactory) {
        this._applicationRef = _applicationRef;
        this._injector = _injector;
        this._document = _document;
        this._scrollBar = _scrollBar;
        this._rendererFactory = _rendererFactory;
        this._activeWindowCmptHasChanged = new Subject();
        this._ariaHiddenValues = new Map();
        this._backdropAttributes = ['backdropClass'];
        this._modalRefs = [];
        this._windowAttributes = ['ariaLabelledBy', 'backdrop', 'centered', 'keyboard', 'size', 'windowClass'];
        this._windowCmpts = [];
        // Trap focus on active WindowCmpt
        this._activeWindowCmptHasChanged.subscribe(() => {
            if (this._windowCmpts.length) {
                /** @type {?} */
                const activeWindowCmpt = this._windowCmpts[this._windowCmpts.length - 1];
                FocusTrap(activeWindowCmpt.location.nativeElement, this._activeWindowCmptHasChanged);
                this._revertAriaHidden();
                this._setAriaHidden(activeWindowCmpt.location.nativeElement);
            }
        });
    }
    /**
     * @param {?} moduleCFR
     * @param {?} contentInjector
     * @param {?} content
     * @param {?} options
     * @return {?}
     */
    open(moduleCFR, contentInjector, content, options) {
        /** @type {?} */
        const containerEl = isDefined(options.container) ? this._document.querySelector(options.container) : this._document.body;
        /** @type {?} */
        const renderer = this._rendererFactory.createRenderer(null, null);
        /** @type {?} */
        const revertPaddingForScrollBar = this._scrollBar.compensate();
        /** @type {?} */
        const removeBodyClass = () => {
            if (!this._modalRefs.length) {
                renderer.removeClass(this._document.body, 'modal-open');
                this._revertAriaHidden();
            }
        };
        if (!containerEl) {
            throw new Error(`The specified modal container "${options.container || 'body'}" was not found in the DOM.`);
        }
        /** @type {?} */
        const activeModal = new NgbActiveModal();
        /** @type {?} */
        const contentRef = this._getContentRef(moduleCFR, options.injector || contentInjector, content, activeModal);
        /** @type {?} */
        let backdropCmptRef = options.backdrop !== false ? this._attachBackdrop(moduleCFR, containerEl) : null;
        /** @type {?} */
        let windowCmptRef = this._attachWindowComponent(moduleCFR, containerEl, contentRef);
        /** @type {?} */
        let ngbModalRef = new NgbModalRef(windowCmptRef, contentRef, backdropCmptRef, options.beforeDismiss);
        this._registerModalRef(ngbModalRef);
        this._registerWindowCmpt(windowCmptRef);
        ngbModalRef.result.then(revertPaddingForScrollBar, revertPaddingForScrollBar);
        ngbModalRef.result.then(removeBodyClass, removeBodyClass);
        activeModal.close = (result) => { ngbModalRef.close(result); };
        activeModal.dismiss = (reason) => { ngbModalRef.dismiss(reason); };
        this._applyWindowOptions(windowCmptRef.instance, options);
        if (this._modalRefs.length === 1) {
            renderer.addClass(this._document.body, 'modal-open');
        }
        if (backdropCmptRef && backdropCmptRef.instance) {
            this._applyBackdropOptions(backdropCmptRef.instance, options);
        }
        return ngbModalRef;
    }
    /**
     * @param {?=} reason
     * @return {?}
     */
    dismissAll(reason) { this._modalRefs.forEach(ngbModalRef => ngbModalRef.dismiss(reason)); }
    /**
     * @return {?}
     */
    hasOpenModals() { return this._modalRefs.length > 0; }
    /**
     * @param {?} moduleCFR
     * @param {?} containerEl
     * @return {?}
     */
    _attachBackdrop(moduleCFR, containerEl) {
        /** @type {?} */
        let backdropFactory = moduleCFR.resolveComponentFactory(NgbModalBackdrop);
        /** @type {?} */
        let backdropCmptRef = backdropFactory.create(this._injector);
        this._applicationRef.attachView(backdropCmptRef.hostView);
        containerEl.appendChild(backdropCmptRef.location.nativeElement);
        return backdropCmptRef;
    }
    /**
     * @param {?} moduleCFR
     * @param {?} containerEl
     * @param {?} contentRef
     * @return {?}
     */
    _attachWindowComponent(moduleCFR, containerEl, contentRef) {
        /** @type {?} */
        let windowFactory = moduleCFR.resolveComponentFactory(NgbModalWindow);
        /** @type {?} */
        let windowCmptRef = windowFactory.create(this._injector, contentRef.nodes);
        this._applicationRef.attachView(windowCmptRef.hostView);
        containerEl.appendChild(windowCmptRef.location.nativeElement);
        return windowCmptRef;
    }
    /**
     * @param {?} windowInstance
     * @param {?} options
     * @return {?}
     */
    _applyWindowOptions(windowInstance, options) {
        this._windowAttributes.forEach((optionName) => {
            if (isDefined(options[optionName])) {
                windowInstance[optionName] = options[optionName];
            }
        });
    }
    /**
     * @param {?} backdropInstance
     * @param {?} options
     * @return {?}
     */
    _applyBackdropOptions(backdropInstance, options) {
        this._backdropAttributes.forEach((optionName) => {
            if (isDefined(options[optionName])) {
                backdropInstance[optionName] = options[optionName];
            }
        });
    }
    /**
     * @param {?} moduleCFR
     * @param {?} contentInjector
     * @param {?} content
     * @param {?} activeModal
     * @return {?}
     */
    _getContentRef(moduleCFR, contentInjector, content, activeModal) {
        if (!content) {
            return new ContentRef([]);
        }
        else if (content instanceof TemplateRef) {
            return this._createFromTemplateRef(content, activeModal);
        }
        else if (isString(content)) {
            return this._createFromString(content);
        }
        else {
            return this._createFromComponent(moduleCFR, contentInjector, content, activeModal);
        }
    }
    /**
     * @param {?} content
     * @param {?} activeModal
     * @return {?}
     */
    _createFromTemplateRef(content, activeModal) {
        /** @type {?} */
        const context = {
            $implicit: activeModal,
            /**
             * @param {?} result
             * @return {?}
             */
            close(result) { activeModal.close(result); },
            /**
             * @param {?} reason
             * @return {?}
             */
            dismiss(reason) { activeModal.dismiss(reason); }
        };
        /** @type {?} */
        const viewRef = content.createEmbeddedView(context);
        this._applicationRef.attachView(viewRef);
        return new ContentRef([viewRef.rootNodes], viewRef);
    }
    /**
     * @param {?} content
     * @return {?}
     */
    _createFromString(content) {
        /** @type {?} */
        const component = this._document.createTextNode(`${content}`);
        return new ContentRef([[component]]);
    }
    /**
     * @param {?} moduleCFR
     * @param {?} contentInjector
     * @param {?} content
     * @param {?} context
     * @return {?}
     */
    _createFromComponent(moduleCFR, contentInjector, content, context) {
        /** @type {?} */
        const contentCmptFactory = moduleCFR.resolveComponentFactory(content);
        /** @type {?} */
        const modalContentInjector = Injector.create({ providers: [{ provide: NgbActiveModal, useValue: context }], parent: contentInjector });
        /** @type {?} */
        const componentRef = contentCmptFactory.create(modalContentInjector);
        this._applicationRef.attachView(componentRef.hostView);
        return new ContentRef([[componentRef.location.nativeElement]], componentRef.hostView, componentRef);
    }
    /**
     * @param {?} element
     * @return {?}
     */
    _setAriaHidden(element) {
        /** @type {?} */
        const parent = element.parentElement;
        if (parent && element !== this._document.body) {
            Array.from(parent.children).forEach(sibling => {
                if (sibling !== element && sibling.nodeName !== 'SCRIPT') {
                    this._ariaHiddenValues.set(sibling, sibling.getAttribute('aria-hidden'));
                    sibling.setAttribute('aria-hidden', 'true');
                }
            });
            this._setAriaHidden(parent);
        }
    }
    /**
     * @return {?}
     */
    _revertAriaHidden() {
        this._ariaHiddenValues.forEach((value, element) => {
            if (value) {
                element.setAttribute('aria-hidden', value);
            }
            else {
                element.removeAttribute('aria-hidden');
            }
        });
        this._ariaHiddenValues.clear();
    }
    /**
     * @param {?} ngbModalRef
     * @return {?}
     */
    _registerModalRef(ngbModalRef) {
        /** @type {?} */
        const unregisterModalRef = () => {
            /** @type {?} */
            const index = this._modalRefs.indexOf(ngbModalRef);
            if (index > -1) {
                this._modalRefs.splice(index, 1);
            }
        };
        this._modalRefs.push(ngbModalRef);
        ngbModalRef.result.then(unregisterModalRef, unregisterModalRef);
    }
    /**
     * @param {?} ngbWindowCmpt
     * @return {?}
     */
    _registerWindowCmpt(ngbWindowCmpt) {
        this._windowCmpts.push(ngbWindowCmpt);
        this._activeWindowCmptHasChanged.next();
        ngbWindowCmpt.onDestroy(() => {
            /** @type {?} */
            const index = this._windowCmpts.indexOf(ngbWindowCmpt);
            if (index > -1) {
                this._windowCmpts.splice(index, 1);
                this._activeWindowCmptHasChanged.next();
            }
        });
    }
}
NgbModalStack.decorators = [
    { type: Injectable, args: [{ providedIn: 'root' },] }
];
/** @nocollapse */
NgbModalStack.ctorParameters = () => [
    { type: ApplicationRef },
    { type: Injector },
    { type: undefined, decorators: [{ type: Inject, args: [DOCUMENT,] }] },
    { type: ScrollBar },
    { type: RendererFactory2 }
];
/** @nocollapse */ NgbModalStack.ngInjectableDef = defineInjectable({ factory: function NgbModalStack_Factory() { return new NgbModalStack(inject(ApplicationRef), inject(INJECTOR), inject(DOCUMENT), inject(ScrollBar), inject(RendererFactory2)); }, token: NgbModalStack, providedIn: "root" });

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,uselessCode} checked by tsc
 */
/**
 * A service for opening modal windows.
 *
 * Creating a modal is straightforward: create a component or a template and pass it as an argument to
 * the `.open()` method.
 */
class NgbModal {
    /**
     * @param {?} _moduleCFR
     * @param {?} _injector
     * @param {?} _modalStack
     * @param {?} _config
     */
    constructor(_moduleCFR, _injector, _modalStack, _config) {
        this._moduleCFR = _moduleCFR;
        this._injector = _injector;
        this._modalStack = _modalStack;
        this._config = _config;
    }
    /**
     * Opens a new modal window with the specified content and supplied options.
     *
     * Content can be provided as a `TemplateRef` or a component type. If you pass a component type as content,
     * then instances of those components can be injected with an instance of the `NgbActiveModal` class. You can then
     * use `NgbActiveModal` methods to close / dismiss modals from "inside" of your component.
     *
     * Also see the [`NgbModalOptions`](#/components/modal/api#NgbModalOptions) for the list of supported options.
     * @param {?} content
     * @param {?=} options
     * @return {?}
     */
    open(content, options = {}) {
        /** @type {?} */
        const combinedOptions = Object.assign({}, this._config, options);
        return this._modalStack.open(this._moduleCFR, this._injector, content, combinedOptions);
    }
    /**
     * Dismisses all currently displayed modal windows with the supplied reason.
     *
     * \@since 3.1.0
     * @param {?=} reason
     * @return {?}
     */
    dismissAll(reason) { this._modalStack.dismissAll(reason); }
    /**
     * Indicates if there are currently any open modal windows in the application.
     *
     * \@since 3.3.0
     * @return {?}
     */
    hasOpenModals() { return this._modalStack.hasOpenModals(); }
}
NgbModal.decorators = [
    { type: Injectable, args: [{ providedIn: 'root' },] }
];
/** @nocollapse */
NgbModal.ctorParameters = () => [
    { type: ComponentFactoryResolver },
    { type: Injector },
    { type: NgbModalStack },
    { type: NgbModalConfig }
];
/** @nocollapse */ NgbModal.ngInjectableDef = defineInjectable({ factory: function NgbModal_Factory() { return new NgbModal(inject(ComponentFactoryResolver), inject(INJECTOR), inject(NgbModalStack), inject(NgbModalConfig)); }, token: NgbModal, providedIn: "root" });

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,uselessCode} checked by tsc
 */
class ModalComponent {
    /**
     * @param {?} modal
     */
    constructor(modal) {
        this.modal = modal;
        this.closed = new Subject();
        this.options = {
            backdrop: 'static',
            size: 'xl',
            centered: false,
            windowClass: ''
        };
    }
    /**
     * @param {?} backdrop
     * @return {?}
     */
    set backdrop(backdrop) {
        this.options.backdrop = backdrop;
    }
    /**
     * @param {?} size
     * @return {?}
     */
    set size(size) {
        this.options.size = size;
    }
    /**
     * @return {?}
     */
    ngOnInit() {
    }
    /**
     * @return {?}
     */
    open() {
        this.opened = true;
        this.modal
            .open(this.content, this.options)
            .result
            .then((result) => {
            this.closeResult = result;
        }, (reason) => {
            this.closeResult = reason;
        });
    }
    /**
     * @param {?=} reason
     * @return {?}
     */
    close(reason = null) {
        this.opened = false;
        this.modal.dismissAll(reason);
        this.closed.next(reason);
    }
}
ModalComponent.decorators = [
    { type: Component, args: [{
                selector: 'pl-modal',
                template: `
    <ng-template #content let-modal>
      <div class="modal-header">
        <h4 class="modal-title">
          {{title}}
        </h4>
        <button type="button" class="close" (click)="close()">
          <span aria-hidden="true">&times;</span>
        </button>
      </div>
      <div class="modal-body">
        <ng-content></ng-content>
      </div>
    </ng-template>
  `
            }] }
];
/** @nocollapse */
ModalComponent.ctorParameters = () => [
    { type: NgbModal }
];
ModalComponent.propDecorators = {
    content: [{ type: ViewChild, args: ['content',] }],
    title: [{ type: Input }],
    backdrop: [{ type: Input }],
    size: [{ type: Input }],
    closed: [{ type: Output }]
};

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,uselessCode} checked by tsc
 */
/**
 * @param {?=} value
 * @return {?}
 */
function convertToBoolean(value) {
    return value ? value !== 'false' : value === '';
}
/**
 * @template K, T
 * @param {?} target
 * @param {?} key
 * @return {?}
 */
function BooleanInput(target, key) {
    /** @type {?} */
    const privateKey = (/** @type {?} */ ('$$' + key));
    /** @type {?} */
    const propertyDescriptor = Object.getOwnPropertyDescriptor(target, key);
    if (propertyDescriptor) {
        if (!propertyDescriptor.configurable) {
            throw new Error(`BooleanInput is not able to replace a property "${key}".`);
        }
        Object.defineProperty(target, privateKey, propertyDescriptor);
    }
    /** @type {?} */
    const newPropertyDescriptor = {
        configurable: true,
        enumerable: false,
        /**
         * @this {?}
         * @return {?}
         */
        get() {
            return this[privateKey] || false;
        },
        /**
         * @this {?}
         * @param {?} Bvalue
         * @return {?}
         */
        set(Bvalue) {
            this[privateKey] = convertToBoolean(Bvalue);
        },
    };
    if (arguments.length < 3) {
        return Object.defineProperty(target, key, newPropertyDescriptor);
    }
    else {
        return newPropertyDescriptor;
    }
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,uselessCode} checked by tsc
 */
class ListComponent {
    constructor() {
        /**
         * Actives the option to select multiple itens on list
         * This options is enabled by default on actionable lists
         */
        this.selectMultiple = true;
        this.btnSize = 'default';
        this.btnDirection = 'column';
        /**
         * Properties of list objects
         */
        this.propPrimary = 'id';
        this.propOrder = 'order';
        /**
         * Output Events
         */
        this.addItem = new EventEmitter();
        this.clickItem = new EventEmitter();
        this.editItem = new EventEmitter();
        this.removeItem = new EventEmitter();
        this.removeItems = new EventEmitter();
        // used to hide components
        this.isArray = isArray;
    }
    // guards total of items selected
    /**
     * Handles the click event to output item was clicked
     * @param {?} event
     * @param {?} index
     * @param {?} item
     * @return {?}
     */
    click(event, index, item) {
        event.stopPropagation();
        /** @type {?} */
        const status = !!item.active;
        if (this.actionable) {
            if (!this.selectMultiple) {
                this.list.forEach(i => i.active = false);
            }
            item.active = !status;
            this.totalSelected = this.list
                .filter(i => i.active).length;
            if (!this.selectMultiple && status) {
                this.clickItem.emit({ index: null, item: null });
                return;
            }
        }
        this.clickItem.emit({ index, item });
    }
    /**
     * Output when users clicks on edit button
     * @param {?} index
     * @param {?} item
     * @return {?}
     */
    edit(index, item) {
        this.editItem.emit({ index, item });
    }
    /**
     * Output when users clicks on remove button
     * @param {?} index
     * @param {?} item
     * @return {?}
     */
    remove(index, item) {
        this.removeItem.emit({ index, item });
    }
    /**
     * Output when users clicks on remove all button
     * this emit all items selected
     * @return {?}
     */
    removeSelected() {
        this.removeItems.emit({ item: this.list.filter(i => i.active) });
    }
    /* SORT LIST CONTROL */
    /**
     * @param {?} event
     * @return {?}
     */
    drop(event) {
        if (!this.orderValidator)
            return;
        if (event.previousIndex === event.currentIndex)
            return;
        moveItemInArray(this.list, event.previousIndex, event.currentIndex);
        /** @type {?} */
        const changes = this.getOrderChanges(this.list);
        if (!this.orderValidator)
            return;
        this.busy = true;
        this.orderValidator(changes)
            .subscribe(status => {
            console.log(`Order Validator return => [ ${status} ]`);
            if (!status) {
                moveItemInArray(event.container.data, event.currentIndex, event.previousIndex);
            }
            else {
                this.setOrderChanges(changes);
            }
            this.busy = false;
        });
    }
    /**
     * @param {?} list
     * @return {?}
     */
    getOrderChanges(list) {
        /** @type {?} */
        const changes = [];
        list.forEach((v, i) => {
            if (v[this.propOrder] !== i) {
                changes.push({
                    [this.propPrimary]: v[this.propPrimary],
                    [this.propOrder]: i
                });
            }
        });
        return changes;
    }
    /**
     * @param {?} list
     * @return {?}
     */
    setOrderChanges(list) {
        list.forEach(i => {
            /** @type {?} */
            const itemFound = this.list
                .find(item => item[this.propPrimary] === i[this.propPrimary]);
            itemFound[this.propOrder] = i[this.propOrder];
        });
    }
}
ListComponent.decorators = [
    { type: Component, args: [{
                // tslint:disable-next-line:component-selector
                selector: 'pl-list',
                template: "<pl-loading\n  [loading]=\"loading || busy\"\n></pl-loading>\n\n<div\n  class=\"list-wrapper\"\n  *ngIf=\"!loading && !busy\"\n>\n  <div\n    class=\"list-group-toolbar bg-light border-bottom border-top\"\n    *ngIf=\"showToolbar && list && list.length > 0\"\n  >\n    <div class=\"toolbar-statistics\">\n      <span *ngIf=\"list\"><b>Total: </b>{{list.length}} items</span>\n      <span *ngIf=\"totalSelected\"><b>Selecionados: </b>{{totalSelected}} items</span>\n    </div>\n    <div class=\"toolbar-controls\">\n      <pl-button\n        class=\"mr-2\"\n        *ngIf=\"totalSelected\"\n        icon=\"trash-alt\"\n        btn-style=\"outline-danger\"\n        (click)=\"removeSelected()\"\n        [btn-size]=\"btnSize\"\n        text=\"Remover Selecionados\"\n        [tooltip]=\"'Remove os ('+totalSelected+') itens selecionados'\"\n        tooltip-class=\"danger\"\n      ></pl-button>\n\n      <pl-button\n        *ngIf=\"addItem.observers.length > 0\"\n        icon=\"plus\"\n        [text]=\"btnAddText\"\n        btn-style=\"outline-info\"\n        [btn-size]=\"btnSize\"\n        (click)=\"addItem.emit()\"\n        tooltip=\"Criar um novo item\"\n        tooltip-class=\"info\"\n      ></pl-button>\n    </div>\n\n  </div>\n  <ul\n    class=\"list-group\"\n    [class.list-group-flush]=\"flush\"\n    cdkDropList\n    [cdkDropListData]=\"list\"\n    (cdkDropListDropped)=\"drop($event)\"\n    [cdkDropListDisabled]=\"!sortable\"\n  >\n    <li\n      *ngFor=\"let item of list; let i = index\"\n      class=\"list-group-item\"\n      [class.list-group-item-action]=\"actionable\"\n      [class.active]=\"item.active\"\n      (click)=\"click($event, i, item)\"\n      cdkDrag\n      cdkDragLockAxis=\"y\"\n    >\n      <div\n        class=\"list-group-content\"\n      >\n\n        <div class=\"list-data d-flex flex-grow-1 align-items-center\">\n\n          <div class=\"list-data-icon mr-2\" *ngIf=\"icon || propIcon || showOrders\">\n            <div\n              *ngIf=\"showOrders\"\n              class=\"badge badge-primary\"\n            >{{i + 1}}</div>\n\n            <fa-icon\n              *ngIf=\"icon\"\n              [icon]=\"icon\"\n              [class.ml-2]=\"showOrders\"\n              size=\"3x\"\n            ></fa-icon>\n\n            <fa-icon\n              *ngIf=\"propIcon\"\n              [class.ml-2]=\"showOrders || icon\"\n              [icon]=\"item[propIcon]\"\n              size=\"3x\"\n            ></fa-icon>\n          </div>\n\n          <div class=\"list-data-content flex-grow-1\">\n\n            <h2\n              *ngIf=\"propTitle\"\n              class=\"mb-0\"\n            >{{item[propTitle]}}</h2>\n\n            <ng-container *ngIf=\"isArray(propText)\">\n              <div\n                class=\"list-item-text\"\n                *ngFor=\"let prop of propText\"\n              >\n                {{item[prop]}}\n              </div>\n            </ng-container>\n\n            <ng-container *ngIf=\"!isArray(propText)\">\n              {{item[propText]}}\n            </ng-container>\n\n          </div>\n\n        </div>\n\n        <div\n          class=\"list-buttons\"\n          [ngClass]=\"btnDirection\"\n        >\n          <pl-button\n            *ngIf=\"editItem.observers.length > 0\"\n            icon=\"pencil-alt\"\n            [btn-size]=\"btnSize\"\n            btn-style=\"outline-warning\"\n            (click)=\"edit(i, item)\"\n            tooltip=\"Editar Item\"\n            tooltip-class=\"warning\"\n          ></pl-button>\n\n          <pl-button\n            [class.mt-1]=\"btnDirection === 'column'\"\n            [class.ml-1]=\"btnDirection === 'row'\"\n            *ngIf=\"removeItem.observers.length > 0\"\n            icon=\"trash-alt\"\n            [btn-size]=\"btnSize\"\n            btn-style=\"outline-danger\"\n            tooltip=\"Remover Item\"\n            tooltip-class=\"danger\"\n            (click)=\"remove(i, item)\"\n          ></pl-button>\n\n          <ng-container *ngTemplateOutlet=\"buttons\">\n          </ng-container>\n        </div>\n\n      </div>\n\n    </li>\n\n  </ul>\n</div>\n\n",
                styles: [".list-group-toolbar{display:flex;align-items:center;padding:.5rem 1rem}.list-group-toolbar .toolbar-statistics{flex-grow:1}.list-group-toolbar .toolbar-statistics span:not(:first-child){margin-left:1rem}.list-group-content{display:flex;flex-direction:row;justify-content:space-between}.list-buttons{display:flex;flex-direction:column;align-content:flex-start}.list-buttons app-button{margin:0 0 5px}.list-buttons:empty{display:none}.list-buttons.row{flex-direction:row}.list-buttons.column{flex-direction:column}@media (max-width:576px){.list-group-content{flex-direction:column}.list-buttons{flex-direction:row;justify-content:flex-end}.list-buttons app-button{margin:0 5px 0 0}}.cdk-drag-preview{box-sizing:border-box;border-radius:4px;box-shadow:0 5px 5px -3px rgba(0,0,0,.2),0 8px 10px 1px rgba(0,0,0,.14),0 3px 14px 2px rgba(0,0,0,.12)}.cdk-drag-animating{transition:transform 250ms cubic-bezier(0,0,.2,1)}.example-custom-placeholder{background:#ccc;border:3px dotted #999;min-height:60px;transition:transform 250ms cubic-bezier(0,0,.2,1)}"]
            }] }
];
ListComponent.propDecorators = {
    actionable: [{ type: Input }],
    selectMultiple: [{ type: Input, args: ['select-multiple',] }],
    btnAddText: [{ type: Input, args: ['btn-add-text',] }],
    btnSize: [{ type: Input, args: ['btn-size',] }],
    btnDirection: [{ type: Input, args: ['btn-direction',] }],
    flush: [{ type: Input }],
    sortable: [{ type: Input, args: ['sortable',] }],
    draggable: [{ type: Input, args: ['draggable',] }],
    icon: [{ type: Input, args: ['icon',] }],
    list: [{ type: Input, args: ['list',] }],
    loading: [{ type: Input, args: ['loading',] }],
    propPrimary: [{ type: Input, args: ['prop-primary',] }],
    propIcon: [{ type: Input, args: ['prop-icon',] }],
    propTitle: [{ type: Input, args: ['prop-title',] }],
    propText: [{ type: Input, args: ['prop-text',] }],
    propOrder: [{ type: Input, args: ['prop-order',] }],
    showToolbar: [{ type: Input, args: ['show-toolbar',] }],
    showOrders: [{ type: Input, args: ['show-orders',] }],
    orderValidator: [{ type: Input }],
    addItem: [{ type: Output }],
    clickItem: [{ type: Output }],
    editItem: [{ type: Output }],
    removeItem: [{ type: Output }],
    removeItems: [{ type: Output }],
    buttons: [{ type: ContentChild, args: ['listButtons',] }],
    toolbarButtons: [{ type: ContentChild, args: ['toolbarButtons',] }]
};
__decorate([
    BooleanInput,
    __metadata("design:type", Boolean)
], ListComponent.prototype, "actionable", void 0);
__decorate([
    BooleanInput,
    __metadata("design:type", Boolean)
], ListComponent.prototype, "flush", void 0);
__decorate([
    BooleanInput,
    __metadata("design:type", Boolean)
], ListComponent.prototype, "sortable", void 0);
__decorate([
    BooleanInput,
    __metadata("design:type", Boolean)
], ListComponent.prototype, "showToolbar", void 0);
__decorate([
    BooleanInput,
    __metadata("design:type", Boolean)
], ListComponent.prototype, "showOrders", void 0);

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,uselessCode} checked by tsc
 */
class ButtonComponent {
    constructor() {
        this.size = 'default';
        this.btnStyle = 'primary';
        this.btnType = 'button';
        this.tooltipClass = 'primary';
        this.tooltipPlacement = 'auto';
        this.click = new EventEmitter();
    }
    /**
     * @param {?} event
     * @return {?}
     */
    clicked(event) {
        event.stopPropagation();
        this.click.emit();
    }
}
ButtonComponent.decorators = [
    { type: Component, args: [{
                selector: 'pl-button',
                template: "<button\n  [type]=\"btnType\"\n  class=\"btn\"\n  [ngClass]=\"'btn-'+btnStyle\"\n  [class.btn-sm]=\"size==='small'\"\n  [class.btn-lg]=\"size==='large'\"\n  (click)=\"clicked($event)\"\n  [tooltip]=\"tooltip ? tooltipTemplate : null\"\n  [tooltipClass]=\"tooltipClass\"\n  [placement]=\"tooltipPlacement\"\n>\n\n  <fa-icon\n    *ngIf=\"icon\"\n    [fixedWidth]=\"true\"\n    [icon]=\"icon\"\n  ></fa-icon>\n\n  <span *ngIf=\"text\">{{text}}</span>\n\n  <ng-content></ng-content>\n\n</button>\n\n<ng-template\n  #tooltipTemplate\n>\n  <fa-icon\n    class=\"mr-1\"\n    *ngIf=\"tooltipIcon\"\n    [icon]=\"tooltipIcon\"\n  ></fa-icon>\n  {{tooltip}}\n</ng-template>\n\n",
                styles: [""]
            }] }
];
ButtonComponent.propDecorators = {
    size: [{ type: Input, args: ['btn-size',] }],
    btnStyle: [{ type: Input, args: ['btn-style',] }],
    btnType: [{ type: Input, args: ['btn-type',] }],
    icon: [{ type: Input }],
    text: [{ type: Input }],
    tooltip: [{ type: Input, args: ['tooltip-text',] }],
    tooltipIcon: [{ type: Input, args: ['tooltip-icon',] }],
    tooltipClass: [{ type: Input, args: ['tooltip-class',] }],
    tooltipPlacement: [{ type: Input, args: ['tooltip-placement',] }],
    click: [{ type: Output }]
};

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,uselessCode} checked by tsc
 */
class SubmitComponent {
    constructor() {
        this.centered = true;
        this.submit = new EventEmitter();
        this.cancelled = new EventEmitter();
    }
    /**
     * @return {?}
     */
    ngOnInit() {
    }
}
SubmitComponent.decorators = [
    { type: Component, args: [{
                selector: 'pf-submit',
                template: "<div class=\"row\">\n  <div\n    class=\"col-md-12 py-3\"\n    [class.text-center]=\"centered\"\n  >\n    <pl-button\n      btn-style=\"outline-info\"\n      text=\"Salvar\"\n      btn-type=\"submit\"\n      (click)=\"submit.emit()\"\n    ></pl-button>\n\n    <pl-button\n      class=\"ml-2\"\n      btn-style=\"outline-danger\"\n      text=\"Cancelar\"\n      btn-type=\"button\"\n      (click)=\"cancelled.emit()\"\n    ></pl-button>\n\n  </div>\n</div>\n",
                styles: [""]
            }] }
];
/** @nocollapse */
SubmitComponent.ctorParameters = () => [];
SubmitComponent.propDecorators = {
    centered: [{ type: Input }],
    submit: [{ type: Output }],
    cancelled: [{ type: Output }]
};
__decorate([
    BooleanInput,
    __metadata("design:type", Object)
], SubmitComponent.prototype, "centered", void 0);

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,uselessCode} checked by tsc
 */
class LoadingComponent {
    constructor() { }
    /**
     * @return {?}
     */
    ngOnInit() {
    }
}
LoadingComponent.decorators = [
    { type: Component, args: [{
                selector: 'pl-loading',
                template: `
    <div class="row" *ngIf="loading">
      <div class="col-md-12 py-3 text-center">
        <icon
          icon="spinner"
          [pulse]="true"
          size="3x"
        ></icon>
      </div>
    </div>
  `,
                styles: [""]
            }] }
];
/** @nocollapse */
LoadingComponent.ctorParameters = () => [];
LoadingComponent.propDecorators = {
    loading: [{ type: Input }]
};

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,uselessCode} checked by tsc
 */
class PageHeaderComponent {
    constructor() {
        this.backgroundColor = '';
        this.textColor = '';
        this.shadow = 'shadow-sm';
    }
    /**
     * @return {?}
     */
    ngOnInit() {
    }
}
PageHeaderComponent.decorators = [
    { type: Component, args: [{
                selector: 'pl-page-header',
                template: "<div\n  class=\"page-header border\"\n  [ngClass]=\"[backgroundColor, textColor, shadow]\"\n>\n\n  <div class=\"header-data\">\n\n    <div\n      class=\"header-icon\"\n      *ngIf=\"icon\"\n    >\n      <fa-icon\n        [icon]=\"icon\"\n        size=\"2x\"\n      ></fa-icon>\n    </div>\n\n    <div class=\"header-text\">\n      <h2>\n        {{pageTitle}}\n      </h2>\n      <p *ngIf=\"desc\">{{desc}}</p>\n    </div>\n  </div>\n\n  <div class=\"header-buttons\">\n    <ng-content select=\"pl-button\"></ng-content>\n  </div>\n\n</div>\n",
                styles: [".page-header{display:flex;flex-direction:row;padding:.5rem 1rem}.page-header .header-data{display:flex;flex-grow:1}.page-header .header-data .header-text{flex-grow:1;align-content:center}.page-header .header-data .header-text h2{margin:0}.page-header .header-data .header-icon{-ms-grid-row-align:center;align-self:center;margin-right:1rem}.page-header .header-buttons{-ms-grid-row-align:center;align-self:center}.page-header .header-buttons app-button:not(:first-child){margin-left:3px}@media (max-width:576px){.page-header{flex-direction:column}.page-header .header-text h2{margin:.7rem 0}.page-header .header-buttons{-ms-grid-row-align:stretch;align-self:stretch}}"]
            }] }
];
/** @nocollapse */
PageHeaderComponent.ctorParameters = () => [];
PageHeaderComponent.propDecorators = {
    icon: [{ type: Input }],
    pageTitle: [{ type: Input, args: ['page-title',] }],
    desc: [{ type: Input }],
    backgroundColor: [{ type: Input, args: ['background-color',] }],
    textColor: [{ type: Input, args: ['text-color',] }],
    shadow: [{ type: Input, args: ['shadow',] }]
};

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,uselessCode} checked by tsc
 */
class MenuComponent {
    constructor() { }
    /**
     * @return {?}
     */
    ngOnInit() {
    }
}
MenuComponent.decorators = [
    { type: Component, args: [{
                selector: 'pl-menu',
                template: "<ul class=\"list-group\">\n  <li class=\"list-group-item list-group-item-action active\">Cras justo odio</li>\n  <li class=\"list-group-item list-group-item-action\">Dapibus ac facilisis in</li>\n  <li class=\"list-group-item list-group-item-action\">Morbi leo risus</li>\n  <li class=\"list-group-item list-group-item-action\">Porta ac consectetur ac</li>\n  <li class=\"list-group-item list-group-item-action\">Vestibulum at eros</li>\n</ul>\n",
                styles: [""]
            }] }
];
/** @nocollapse */
MenuComponent.ctorParameters = () => [];

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,uselessCode} checked by tsc
 */
class Trigger {
    /**
     * @param {?} open
     * @param {?=} close
     */
    constructor(open, close) {
        this.open = open;
        this.close = close;
        if (!close) {
            this.close = open;
        }
    }
    /**
     * @return {?}
     */
    isManual() { return this.open === 'manual' || this.close === 'manual'; }
}
/** @type {?} */
const DEFAULT_ALIASES = {
    'hover': ['mouseenter', 'mouseleave'],
    'focus': ['focusin', 'focusout'],
};
/**
 * @param {?} triggers
 * @param {?=} aliases
 * @return {?}
 */
function parseTriggers(triggers, aliases = DEFAULT_ALIASES) {
    /** @type {?} */
    const trimmedTriggers = (triggers || '').trim();
    if (trimmedTriggers.length === 0) {
        return [];
    }
    /** @type {?} */
    const parsedTriggers = trimmedTriggers.split(/\s+/).map(trigger$$1 => trigger$$1.split(':')).map((triggerPair) => {
        /** @type {?} */
        let alias = aliases[triggerPair[0]] || triggerPair;
        return new Trigger(alias[0], alias[1]);
    });
    /** @type {?} */
    const manualTriggers = parsedTriggers.filter(triggerPair => triggerPair.isManual());
    if (manualTriggers.length > 1) {
        throw 'Triggers parse error: only one manual trigger is allowed';
    }
    if (manualTriggers.length === 1 && parsedTriggers.length > 1) {
        throw 'Triggers parse error: manual trigger can\'t be mixed with other triggers';
    }
    return parsedTriggers;
}
/**
 * @param {?} renderer
 * @param {?} nativeElement
 * @param {?} triggers
 * @param {?} isOpenedFn
 * @return {?}
 */
function observeTriggers(renderer, nativeElement, triggers, isOpenedFn) {
    return new Observable(subscriber => {
        /** @type {?} */
        const listeners = [];
        /** @type {?} */
        const openFn = () => subscriber.next(true);
        /** @type {?} */
        const closeFn = () => subscriber.next(false);
        /** @type {?} */
        const toggleFn = () => subscriber.next(!isOpenedFn());
        triggers.forEach((trigger$$1) => {
            if (trigger$$1.open === trigger$$1.close) {
                listeners.push(renderer.listen(nativeElement, trigger$$1.open, toggleFn));
            }
            else {
                listeners.push(renderer.listen(nativeElement, trigger$$1.open, openFn), renderer.listen(nativeElement, trigger$$1.close, closeFn));
            }
        });
        return () => { listeners.forEach(unsubscribeFn => unsubscribeFn()); };
    });
}
/** @type {?} */
const delayOrNoop = (time) => time > 0 ? delay(time) : (a) => a;
/**
 * @param {?} openDelay
 * @param {?} closeDelay
 * @param {?} isOpenedFn
 * @return {?}
 */
function triggerDelay(openDelay, closeDelay, isOpenedFn) {
    return (input$) => {
        /** @type {?} */
        let pending = null;
        /** @type {?} */
        const filteredInput$ = input$.pipe(map(open => ({ open })), filter(event => {
            /** @type {?} */
            const currentlyOpen = isOpenedFn();
            if (currentlyOpen !== event.open && (!pending || pending.open === currentlyOpen)) {
                pending = event;
                return true;
            }
            if (pending && pending.open !== event.open) {
                pending = null;
            }
            return false;
        }), share());
        /** @type {?} */
        const delayedOpen$ = filteredInput$.pipe(filter(event => event.open), delayOrNoop(openDelay));
        /** @type {?} */
        const delayedClose$ = filteredInput$.pipe(filter(event => !event.open), delayOrNoop(closeDelay));
        return merge(delayedOpen$, delayedClose$)
            .pipe(filter(event => {
            if (event === pending) {
                pending = null;
                return event.open !== isOpenedFn();
            }
            return false;
        }), map(event => event.open));
    };
}
/**
 * @param {?} renderer
 * @param {?} nativeElement
 * @param {?} triggers
 * @param {?} isOpenedFn
 * @param {?} openFn
 * @param {?} closeFn
 * @param {?=} openDelay
 * @param {?=} closeDelay
 * @return {?}
 */
function listenToTriggers(renderer, nativeElement, triggers, isOpenedFn, openFn, closeFn, openDelay = 0, closeDelay = 0) {
    /** @type {?} */
    const parsedTriggers = parseTriggers(triggers);
    if (parsedTriggers.length === 1 && parsedTriggers[0].isManual()) {
        return () => { };
    }
    /** @type {?} */
    const subscription = observeTriggers(renderer, nativeElement, parsedTriggers, isOpenedFn)
        .pipe(triggerDelay(openDelay, closeDelay, isOpenedFn))
        .subscribe(open => (open ? openFn() : closeFn()));
    return () => subscription.unsubscribe();
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,uselessCode} checked by tsc
 */
/** @type {?} */
const isContainedIn = (element, array) => array ? array.some(item => item.contains(element)) : false;
/** @type {?} */
const matchesSelectorIfAny = (element, selector) => !selector || closest(element, selector) != null;
// we'll have to use 'touch' events instead of 'mouse' events on iOS and add a more significant delay
// to avoid re-opening when handling (click) on a toggling element
// TODO: use proper Angular platform detection when NgbAutoClose becomes a service and we can inject PLATFORM_ID
/** @type {?} */
let iOS = false;
if (typeof navigator !== 'undefined') {
    iOS = !!navigator.userAgent && /iPad|iPhone|iPod/.test(navigator.userAgent);
}
/**
 * @param {?} zone
 * @param {?} document
 * @param {?} type
 * @param {?} close
 * @param {?} closed$
 * @param {?} insideElements
 * @param {?=} ignoreElements
 * @param {?=} insideSelector
 * @return {?}
 */
function ngbAutoClose(zone, document, type, close, closed$, insideElements, ignoreElements, insideSelector) {
    // closing on ESC and outside clicks
    if (type) {
        zone.runOutsideAngular(() => {
            /** @type {?} */
            const shouldCloseOnClick = (event) => {
                /** @type {?} */
                const element = (/** @type {?} */ (event.target));
                if ((event instanceof MouseEvent && event.button === 2) || isContainedIn(element, ignoreElements)) {
                    return false;
                }
                if (type === 'inside') {
                    return isContainedIn(element, insideElements) && matchesSelectorIfAny(element, insideSelector);
                }
                else if (type === 'outside') {
                    return !isContainedIn(element, insideElements);
                }
                else /* if (type === true) */ {
                    return matchesSelectorIfAny(element, insideSelector) || !isContainedIn(element, insideElements);
                }
            };
            /** @type {?} */
            const escapes$ = fromEvent(document, 'keydown')
                .pipe(takeUntil(closed$), 
            // tslint:disable-next-line:deprecation
            filter(e => e.which === Key.Escape));
            // we have to pre-calculate 'shouldCloseOnClick' on 'mousedown/touchstart',
            // because on 'mouseup/touchend' DOM nodes might be detached
            /** @type {?} */
            const mouseDowns$ = fromEvent(document, iOS ? 'touchstart' : 'mousedown')
                .pipe(map(shouldCloseOnClick), takeUntil(closed$));
            /** @type {?} */
            const closeableClicks$ = fromEvent(document, iOS ? 'touchend' : 'mouseup')
                .pipe(withLatestFrom(mouseDowns$), filter(([_, shouldClose]) => shouldClose), delay(iOS ? 16 : 0), takeUntil(closed$));
            race([escapes$, closeableClicks$]).subscribe(() => zone.run(close));
        });
    }
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,uselessCode} checked by tsc
 */
// previous version:
// https://github.com/angular-ui/bootstrap/blob/07c31d0731f7cb068a1932b8e01d2312b796b4ec/src/position/position.js
class Positioning {
    /**
     * @param {?} element
     * @return {?}
     */
    getAllStyles(element) { return window.getComputedStyle(element); }
    /**
     * @param {?} element
     * @param {?} prop
     * @return {?}
     */
    getStyle(element, prop) { return this.getAllStyles(element)[prop]; }
    /**
     * @param {?} element
     * @return {?}
     */
    isStaticPositioned(element) {
        return (this.getStyle(element, 'position') || 'static') === 'static';
    }
    /**
     * @param {?} element
     * @return {?}
     */
    offsetParent(element) {
        /** @type {?} */
        let offsetParentEl = (/** @type {?} */ (element.offsetParent)) || document.documentElement;
        while (offsetParentEl && offsetParentEl !== document.documentElement && this.isStaticPositioned(offsetParentEl)) {
            offsetParentEl = (/** @type {?} */ (offsetParentEl.offsetParent));
        }
        return offsetParentEl || document.documentElement;
    }
    /**
     * @param {?} element
     * @param {?=} round
     * @return {?}
     */
    position(element, round = true) {
        /** @type {?} */
        let elPosition;
        /** @type {?} */
        let parentOffset = { width: 0, height: 0, top: 0, bottom: 0, left: 0, right: 0 };
        if (this.getStyle(element, 'position') === 'fixed') {
            elPosition = element.getBoundingClientRect();
            elPosition = {
                top: elPosition.top,
                bottom: elPosition.bottom,
                left: elPosition.left,
                right: elPosition.right,
                height: elPosition.height,
                width: elPosition.width
            };
        }
        else {
            /** @type {?} */
            const offsetParentEl = this.offsetParent(element);
            elPosition = this.offset(element, false);
            if (offsetParentEl !== document.documentElement) {
                parentOffset = this.offset(offsetParentEl, false);
            }
            parentOffset.top += offsetParentEl.clientTop;
            parentOffset.left += offsetParentEl.clientLeft;
        }
        elPosition.top -= parentOffset.top;
        elPosition.bottom -= parentOffset.top;
        elPosition.left -= parentOffset.left;
        elPosition.right -= parentOffset.left;
        if (round) {
            elPosition.top = Math.round(elPosition.top);
            elPosition.bottom = Math.round(elPosition.bottom);
            elPosition.left = Math.round(elPosition.left);
            elPosition.right = Math.round(elPosition.right);
        }
        return elPosition;
    }
    /**
     * @param {?} element
     * @param {?=} round
     * @return {?}
     */
    offset(element, round = true) {
        /** @type {?} */
        const elBcr = element.getBoundingClientRect();
        /** @type {?} */
        const viewportOffset = {
            top: window.pageYOffset - document.documentElement.clientTop,
            left: window.pageXOffset - document.documentElement.clientLeft
        };
        /** @type {?} */
        let elOffset = {
            height: elBcr.height || element.offsetHeight,
            width: elBcr.width || element.offsetWidth,
            top: elBcr.top + viewportOffset.top,
            bottom: elBcr.bottom + viewportOffset.top,
            left: elBcr.left + viewportOffset.left,
            right: elBcr.right + viewportOffset.left
        };
        if (round) {
            elOffset.height = Math.round(elOffset.height);
            elOffset.width = Math.round(elOffset.width);
            elOffset.top = Math.round(elOffset.top);
            elOffset.bottom = Math.round(elOffset.bottom);
            elOffset.left = Math.round(elOffset.left);
            elOffset.right = Math.round(elOffset.right);
        }
        return elOffset;
    }
    /*
        Return false if the element to position is outside the viewport
      */
    /**
     * @param {?} hostElement
     * @param {?} targetElement
     * @param {?} placement
     * @param {?=} appendToBody
     * @return {?}
     */
    positionElements(hostElement, targetElement, placement, appendToBody) {
        const [placementPrimary = 'top', placementSecondary = 'center'] = placement.split('-');
        /** @type {?} */
        const hostElPosition = appendToBody ? this.offset(hostElement, false) : this.position(hostElement, false);
        /** @type {?} */
        const targetElStyles = this.getAllStyles(targetElement);
        /** @type {?} */
        const marginTop = parseFloat(targetElStyles.marginTop);
        /** @type {?} */
        const marginBottom = parseFloat(targetElStyles.marginBottom);
        /** @type {?} */
        const marginLeft = parseFloat(targetElStyles.marginLeft);
        /** @type {?} */
        const marginRight = parseFloat(targetElStyles.marginRight);
        /** @type {?} */
        let topPosition = 0;
        /** @type {?} */
        let leftPosition = 0;
        switch (placementPrimary) {
            case 'top':
                topPosition = (hostElPosition.top - (targetElement.offsetHeight + marginTop + marginBottom));
                break;
            case 'bottom':
                topPosition = (hostElPosition.top + hostElPosition.height);
                break;
            case 'left':
                leftPosition = (hostElPosition.left - (targetElement.offsetWidth + marginLeft + marginRight));
                break;
            case 'right':
                leftPosition = (hostElPosition.left + hostElPosition.width);
                break;
        }
        switch (placementSecondary) {
            case 'top':
                topPosition = hostElPosition.top;
                break;
            case 'bottom':
                topPosition = hostElPosition.top + hostElPosition.height - targetElement.offsetHeight;
                break;
            case 'left':
                leftPosition = hostElPosition.left;
                break;
            case 'right':
                leftPosition = hostElPosition.left + hostElPosition.width - targetElement.offsetWidth;
                break;
            case 'center':
                if (placementPrimary === 'top' || placementPrimary === 'bottom') {
                    leftPosition = (hostElPosition.left + hostElPosition.width / 2 - targetElement.offsetWidth / 2);
                }
                else {
                    topPosition = (hostElPosition.top + hostElPosition.height / 2 - targetElement.offsetHeight / 2);
                }
                break;
        }
        /// The translate3d/gpu acceleration render a blurry text on chrome, the next line is commented until a browser fix
        // targetElement.style.transform = `translate3d(${Math.round(leftPosition)}px, ${Math.floor(topPosition)}px, 0px)`;
        targetElement.style.transform = `translate(${Math.round(leftPosition)}px, ${Math.round(topPosition)}px)`;
        // Check if the targetElement is inside the viewport
        /** @type {?} */
        const targetElBCR = targetElement.getBoundingClientRect();
        /** @type {?} */
        const html = document.documentElement;
        /** @type {?} */
        const windowHeight = window.innerHeight || html.clientHeight;
        /** @type {?} */
        const windowWidth = window.innerWidth || html.clientWidth;
        return targetElBCR.left >= 0 && targetElBCR.top >= 0 && targetElBCR.right <= windowWidth &&
            targetElBCR.bottom <= windowHeight;
    }
}
/** @type {?} */
const placementSeparator = /\s+/;
/** @type {?} */
const positionService = new Positioning();
/*
 * Accept the placement array and applies the appropriate placement dependent on the viewport.
 * Returns the applied placement.
 * In case of auto placement, placements are selected in order
 *   'top', 'bottom', 'left', 'right',
 *   'top-left', 'top-right',
 *   'bottom-left', 'bottom-right',
 *   'left-top', 'left-bottom',
 *   'right-top', 'right-bottom'.
 * */
/**
 * @param {?} hostElement
 * @param {?} targetElement
 * @param {?} placement
 * @param {?=} appendToBody
 * @param {?=} baseClass
 * @return {?}
 */
function positionElements(hostElement, targetElement, placement, appendToBody, baseClass) {
    /** @type {?} */
    let placementVals = Array.isArray(placement) ? placement : (/** @type {?} */ (placement.split(placementSeparator)));
    /** @type {?} */
    const allowedPlacements = [
        'top', 'bottom', 'left', 'right', 'top-left', 'top-right', 'bottom-left', 'bottom-right', 'left-top', 'left-bottom',
        'right-top', 'right-bottom'
    ];
    /** @type {?} */
    const classList = targetElement.classList;
    /** @type {?} */
    const addClassesToTarget = (targetPlacement) => {
        const [primary, secondary] = targetPlacement.split('-');
        /** @type {?} */
        const classes = [];
        if (baseClass) {
            classes.push(`${baseClass}-${primary}`);
            if (secondary) {
                classes.push(`${baseClass}-${primary}-${secondary}`);
            }
            classes.forEach((classname) => { classList.add(classname); });
        }
        return classes;
    };
    // Remove old placement classes to avoid issues
    if (baseClass) {
        allowedPlacements.forEach((placementToRemove) => { classList.remove(`${baseClass}-${placementToRemove}`); });
    }
    // replace auto placement with other placements
    /** @type {?} */
    let hasAuto = placementVals.findIndex(val => val === 'auto');
    if (hasAuto >= 0) {
        allowedPlacements.forEach(function (obj) {
            if (placementVals.find(val => val.search('^' + obj) !== -1) == null) {
                placementVals.splice(hasAuto++, 1, (/** @type {?} */ (obj)));
            }
        });
    }
    // coordinates where to position
    // Required for transform:
    /** @type {?} */
    const style$$1 = targetElement.style;
    style$$1.position = 'absolute';
    style$$1.top = '0';
    style$$1.left = '0';
    style$$1['will-change'] = 'transform';
    /** @type {?} */
    let testPlacement;
    /** @type {?} */
    let isInViewport = false;
    for (testPlacement of placementVals) {
        /** @type {?} */
        let addedClasses = addClassesToTarget(testPlacement);
        if (positionService.positionElements(hostElement, targetElement, testPlacement, appendToBody)) {
            isInViewport = true;
            break;
        }
        // Remove the baseClasses for further calculation
        if (baseClass) {
            addedClasses.forEach((classname) => { classList.remove(classname); });
        }
    }
    if (!isInViewport) {
        // If nothing match, the first placement is the default one
        testPlacement = placementVals[0];
        addClassesToTarget(testPlacement);
        positionService.positionElements(hostElement, targetElement, testPlacement, appendToBody);
    }
    return testPlacement;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,uselessCode} checked by tsc
 */
/**
 * A configuration service for the [`TooltipDirective`](#/components/tooltip/api#TooltipDirective) component.
 *
 * You can inject this service, typically in your root component, and customize the values of its properties in
 * order to provide default values for all the tooltips used in the application.
 */
class TooltipConfig {
    constructor() {
        this.autoClose = true;
        this.placement = 'auto';
        this.triggers = 'hover focus';
        this.disableTooltip = false;
        this.openDelay = 0;
        this.closeDelay = 0;
    }
}
TooltipConfig.decorators = [
    { type: Injectable, args: [{ providedIn: 'root' },] }
];
/** @nocollapse */ TooltipConfig.ngInjectableDef = defineInjectable({ factory: function TooltipConfig_Factory() { return new TooltipConfig(); }, token: TooltipConfig, providedIn: "root" });

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,uselessCode} checked by tsc
 */
/** @type {?} */
let nextId = 0;
class TooltipWindowComponent {
}
TooltipWindowComponent.decorators = [
    { type: Component, args: [{
                selector: 'tooltip-window',
                changeDetection: ChangeDetectionStrategy.OnPush,
                encapsulation: ViewEncapsulation.None,
                host: { '[class]': '"tooltip show" + (tooltipClass ? " " +"tooltip-" + tooltipClass : "")', 'role': 'tooltip', '[id]': 'id' },
                template: `<div class="arrow"></div><div class="tooltip-inner"><ng-content></ng-content></div>`,
                styles: ["tooltip-window.bs-tooltip-bottom .arrow,tooltip-window.bs-tooltip-top .arrow{left:calc(50% - .4rem)}tooltip-window.bs-tooltip-bottom-left .arrow,tooltip-window.bs-tooltip-top-left .arrow{left:1em}tooltip-window.bs-tooltip-bottom-right .arrow,tooltip-window.bs-tooltip-top-right .arrow{left:auto;right:.8rem}tooltip-window.bs-tooltip-left .arrow,tooltip-window.bs-tooltip-right .arrow{top:calc(50% - .4rem)}tooltip-window.bs-tooltip-left-top .arrow,tooltip-window.bs-tooltip-right-top .arrow{top:.4rem}tooltip-window.bs-tooltip-left-bottom .arrow,tooltip-window.bs-tooltip-right-bottom .arrow{top:auto;bottom:.4rem}.tooltip.show{opacity:1!important;z-index:9999999}.tooltip-inner{padding:5px 15px}.tooltip-primary .tooltip-inner{background-color:var(--primary);color:var(--light)}.tooltip-primary.bs-tooltip-top .arrow::before{border-top-color:var(--primary)}.tooltip-primary.bs-tooltip-bottom .arrow::before{border-bottom-color:var(--primary)}.tooltip-primary.bs-tooltip-left .arrow::before{border-left-color:var(--primary)}.tooltip-primary.bs-tooltip-right .arrow::before{border-right-color:var(--primary)}.tooltip-secondary .tooltip-inner{background-color:var(--secondary);color:var(--light)}.tooltip-secondary.bs-tooltip-top .arrow::before{border-top-color:var(--secondary)}.tooltip-secondary.bs-tooltip-bottom .arrow::before{border-bottom-color:var(--secondary)}.tooltip-secondary.bs-tooltip-left .arrow::before{border-left-color:var(--secondary)}.tooltip-secondary.bs-tooltip-right .arrow::before{border-right-color:var(--secondary)}.tooltip-danger .tooltip-inner{background-color:var(--danger);color:var(--white)}.tooltip-danger.bs-tooltip-top .arrow::before{border-top-color:var(--danger)}.tooltip-danger.bs-tooltip-bottom .arrow::before{border-bottom-color:var(--danger)}.tooltip-danger.bs-tooltip-left .arrow::before{border-left-color:var(--danger)}.tooltip-danger.bs-tooltip-right .arrow::before{border-right-color:var(--danger)}.tooltip-info .tooltip-inner{background-color:var(--info);color:var(--light)}.tooltip-info.bs-tooltip-top .arrow::before{border-top-color:var(--info)}.tooltip-info.bs-tooltip-bottom .arrow::before{border-bottom-color:var(--info)}.tooltip-info.bs-tooltip-left .arrow::before{border-left-color:var(--info)}.tooltip-info.bs-tooltip-right .arrow::before{border-right-color:var(--info)}.tooltip-light .tooltip-inner{background-color:var(--light);color:var(--dark)}.tooltip-light.bs-tooltip-top .arrow::before{border-top-color:var(--light)}.tooltip-light.bs-tooltip-bottom .arrow::before{border-bottom-color:var(--light)}.tooltip-light.bs-tooltip-left .arrow::before{border-left-color:var(--light)}.tooltip-light.bs-tooltip-right .arrow::before{border-right-color:var(--light)}.tooltip-warning .tooltip-inner{background-color:var(--warning);color:var(--light)}.tooltip-warning.bs-tooltip-top .arrow::before{border-top-color:var(--warning)}.tooltip-warning.bs-tooltip-bottom .arrow::before{border-bottom-color:var(--warning)}.tooltip-warning.bs-tooltip-left .arrow::before{border-left-color:var(--warning)}.tooltip-warning.bs-tooltip-right .arrow::before{border-right-color:var(--warning)}.tooltip-success .tooltip-inner{background-color:var(--success);color:var(--light)}.tooltip-success.bs-tooltip-top .arrow::before{border-top-color:var(--success)}.tooltip-success.bs-tooltip-bottom .arrow::before{border-bottom-color:var(--success)}.tooltip-success.bs-tooltip-left .arrow::before{border-left-color:var(--success)}.tooltip-success.bs-tooltip-right .arrow::before{border-right-color:var(--success)}.tooltip-white .tooltip-inner{background-color:var(--white);color:var(--dark)}.tooltip-white.bs-tooltip-top .arrow::before{border-top-color:var(--white)}.tooltip-white.bs-tooltip-bottom .arrow::before{border-bottom-color:var(--white)}.tooltip-white.bs-tooltip-left .arrow::before{border-left-color:var(--white)}.tooltip-white.bs-tooltip-right .arrow::before{border-right-color:var(--white)}"]
            }] }
];
TooltipWindowComponent.propDecorators = {
    id: [{ type: Input }],
    tooltipClass: [{ type: Input }]
};
/**
 * A lightweight and extensible directive for fancy tooltip creation.
 */
class TooltipDirective {
    /**
     * @param {?} _elementRef
     * @param {?} _renderer
     * @param {?} injector
     * @param {?} componentFactoryResolver
     * @param {?} viewContainerRef
     * @param {?} config
     * @param {?} _ngZone
     * @param {?} _document
     * @param {?} _changeDetector
     * @param {?} _applicationRef
     */
    constructor(_elementRef, _renderer, injector, componentFactoryResolver, viewContainerRef, config, _ngZone, _document, _changeDetector, _applicationRef) {
        this._elementRef = _elementRef;
        this._renderer = _renderer;
        this._ngZone = _ngZone;
        this._document = _document;
        this._changeDetector = _changeDetector;
        this._applicationRef = _applicationRef;
        /**
         * An event emitted when the tooltip is shown. Contains no payload.
         */
        this.shown = new EventEmitter();
        /**
         * An event emitted when the popover is hidden. Contains no payload.
         */
        this.hidden = new EventEmitter();
        this._ngbTooltipWindowId = `tooltip-${nextId++}`;
        this.autoClose = config.autoClose;
        this.placement = config.placement;
        this.triggers = config.triggers;
        this.container = config.container;
        this.disableTooltip = config.disableTooltip;
        this.tooltipClass = config.tooltipClass;
        this.openDelay = config.openDelay;
        this.closeDelay = config.closeDelay;
        this._popupService = new PopupService(TooltipWindowComponent, injector, viewContainerRef, _renderer, componentFactoryResolver, _applicationRef);
        this._zoneSubscription = _ngZone.onStable.subscribe(() => {
            if (this._windowRef) {
                positionElements(this._elementRef.nativeElement, this._windowRef.location.nativeElement, this.placement, this.container === 'body', 'bs-tooltip');
            }
        });
    }
    /**
     * The string content or a `TemplateRef` for the content to be displayed in the tooltip.
     *
     * If the content if falsy, the tooltip won't open.
     * @param {?} value
     * @return {?}
     */
    set tooltip(value) {
        this._tooltip = value;
        if (!value && this._windowRef) {
            this.close();
        }
    }
    /**
     * @return {?}
     */
    get tooltip() { return this._tooltip; }
    /**
     * Opens the tooltip.
     *
     * This is considered to be a "manual" triggering.
     * The `context` is an optional value to be injected into the tooltip template when it is created.
     * @param {?=} context
     * @return {?}
     */
    open(context) {
        if (!this._windowRef && this._tooltip && !this.disableTooltip) {
            this._windowRef = this._popupService.open(this._tooltip, context);
            this._windowRef.instance.tooltipClass = this.tooltipClass;
            this._windowRef.instance.id = this._ngbTooltipWindowId;
            this._renderer.setAttribute(this._elementRef.nativeElement, 'aria-describedby', this._ngbTooltipWindowId);
            if (this.container === 'body') {
                this._document.querySelector(this.container).appendChild(this._windowRef.location.nativeElement);
            }
            // We need to detect changes, because we don't know where .open() might be called from.
            // Ex. opening tooltip from one of lifecycle hooks that run after the CD
            // (say from ngAfterViewInit) will result in 'ExpressionHasChanged' exception
            this._windowRef.changeDetectorRef.detectChanges();
            // We need to mark for check, because tooltip won't work inside the OnPush component.
            // Ex. when we use expression like `{{ tooltip.isOpen() : 'opened' : 'closed' }}`
            // inside the template of an OnPush component and we change the tooltip from
            // open -> closed, the expression in question won't be updated unless we explicitly
            // mark the parent component to be checked.
            this._windowRef.changeDetectorRef.markForCheck();
            ngbAutoClose(this._ngZone, this._document, this.autoClose, () => this.close(), this.hidden, [this._windowRef.location.nativeElement]);
            this.shown.emit();
        }
    }
    /**
     * Closes the tooltip.
     *
     * This is considered to be a "manual" triggering of the tooltip.
     * @return {?}
     */
    close() {
        if (this._windowRef != null) {
            this._renderer.removeAttribute(this._elementRef.nativeElement, 'aria-describedby');
            this._popupService.close();
            this._windowRef = null;
            this.hidden.emit();
            this._changeDetector.markForCheck();
        }
    }
    /**
     * Toggles the tooltip.
     *
     * This is considered to be a "manual" triggering of the tooltip.
     * @return {?}
     */
    toggle() {
        if (this._windowRef) {
            this.close();
        }
        else {
            this.open();
        }
    }
    /**
     * Returns `true`, if the popover is currently shown.
     * @return {?}
     */
    isOpen() { return this._windowRef != null; }
    /**
     * @return {?}
     */
    ngOnInit() {
        this._unregisterListenersFn = listenToTriggers(this._renderer, this._elementRef.nativeElement, this.triggers, this.isOpen.bind(this), this.open.bind(this), this.close.bind(this), +this.openDelay, +this.closeDelay);
    }
    /**
     * @return {?}
     */
    ngOnDestroy() {
        this.close();
        // This check is needed as it might happen that ngOnDestroy is called before ngOnInit
        // under certain conditions, see: https://github.com/ng-bootstrap/ng-bootstrap/issues/2199
        if (this._unregisterListenersFn) {
            this._unregisterListenersFn();
        }
        this._zoneSubscription.unsubscribe();
    }
}
TooltipDirective.decorators = [
    { type: Directive, args: [{ selector: '[tooltip]', exportAs: 'tooltip' },] }
];
/** @nocollapse */
TooltipDirective.ctorParameters = () => [
    { type: ElementRef },
    { type: Renderer2 },
    { type: Injector },
    { type: ComponentFactoryResolver },
    { type: ViewContainerRef },
    { type: TooltipConfig },
    { type: NgZone },
    { type: undefined, decorators: [{ type: Inject, args: [DOCUMENT,] }] },
    { type: ChangeDetectorRef },
    { type: ApplicationRef }
];
TooltipDirective.propDecorators = {
    autoClose: [{ type: Input }],
    placement: [{ type: Input }],
    triggers: [{ type: Input }],
    container: [{ type: Input }],
    disableTooltip: [{ type: Input }],
    tooltipClass: [{ type: Input }],
    openDelay: [{ type: Input }],
    closeDelay: [{ type: Input }],
    shown: [{ type: Output }],
    hidden: [{ type: Output }],
    tooltip: [{ type: Input }]
};

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,uselessCode} checked by tsc
 */
class TooltipModule {
}
TooltipModule.decorators = [
    { type: NgModule, args: [{
                declarations: [TooltipDirective, TooltipWindowComponent],
                exports: [TooltipDirective],
                entryComponents: [TooltipWindowComponent]
            },] }
];

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,uselessCode} checked by tsc
 */
/**
 * A configuration service for the [`Tabset`](#/components/tabset/api#Tabset) component.
 *
 * You can inject this service, typically in your root component, and customize the values of its properties in
 * order to provide default values for all the tabsets used in the application.
 */
class TabsetConfig {
    constructor() {
        this.justify = 'start';
        this.orientation = 'horizontal';
        this.type = 'tabs';
    }
}
TabsetConfig.decorators = [
    { type: Injectable, args: [{ providedIn: 'root' },] }
];
/** @nocollapse */ TabsetConfig.ngInjectableDef = defineInjectable({ factory: function TabsetConfig_Factory() { return new TabsetConfig(); }, token: TabsetConfig, providedIn: "root" });

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,uselessCode} checked by tsc
 */
/** @type {?} */
let nextId$1 = 0;
/**
 * A directive to wrap tab titles that need to contain HTML markup or other directives.
 *
 * Alternatively you could use the `Tab.title` input for string titles.
 */
class TabTitle {
    /**
     * @param {?} templateRef
     */
    constructor(templateRef) {
        this.templateRef = templateRef;
    }
}
TabTitle.decorators = [
    { type: Directive, args: [{ selector: 'ng-template[tabTitle]' },] }
];
/** @nocollapse */
TabTitle.ctorParameters = () => [
    { type: TemplateRef }
];
/**
 * A directive to wrap content to be displayed in a tab.
 */
class TabContent {
    /**
     * @param {?} templateRef
     */
    constructor(templateRef) {
        this.templateRef = templateRef;
    }
}
TabContent.decorators = [
    { type: Directive, args: [{ selector: 'ng-template[tabContent]' },] }
];
/** @nocollapse */
TabContent.ctorParameters = () => [
    { type: TemplateRef }
];
/**
 * A directive representing an individual tab.
 */
class Tab {
    constructor() {
        /**
         * The tab identifier.
         *
         * Must be unique for the entire document for proper accessibility support.
         */
        this.id = `tab-${nextId$1++}`;
        /**
         * If `true`, the current tab is disabled and can't be toggled.
         */
        this.disabled = false;
    }
    /**
     * @return {?}
     */
    ngAfterContentChecked() {
        // We are using @ContentChildren instead of @ContentChild as in the Angular version being used
        // only @ContentChildren allows us to specify the {descendants: false} option.
        // Without {descendants: false} we are hitting bugs described in:
        // https://github.com/ng-bootstrap/ng-bootstrap/issues/2240
        this.titleTpl = this.titleTpls.first;
        this.contentTpl = this.contentTpls.first;
    }
}
Tab.decorators = [
    { type: Directive, args: [{ selector: 'tab' },] }
];
Tab.propDecorators = {
    id: [{ type: Input }],
    title: [{ type: Input }],
    disabled: [{ type: Input }],
    titleTpls: [{ type: ContentChildren, args: [TabTitle, { descendants: false },] }],
    contentTpls: [{ type: ContentChildren, args: [TabContent, { descendants: false },] }]
};
/**
 * A component that makes it easy to create tabbed interface.
 */
class Tabset {
    /**
     * @param {?} config
     */
    constructor(config) {
        /**
         * If `true`, non-visible tabs content will be removed from DOM. Otherwise it will just be hidden.
         */
        this.destroyOnHide = true;
        /**
         * A tab change event emitted right before the tab change happens.
         *
         * See [`TabChangeEvent`](#/components/tabset/api#TabChangeEvent) for payload details.
         */
        this.tabChange = new EventEmitter();
        this.type = config.type;
        this.justify = config.justify;
        this.orientation = config.orientation;
    }
    /**
     * The horizontal alignment of the tabs with flexbox utilities.
     * @param {?} className
     * @return {?}
     */
    set justify(className) {
        if (className === 'fill' || className === 'justified') {
            this.justifyClass = `nav-${className}`;
        }
        else {
            this.justifyClass = `justify-content-${className}`;
        }
    }
    /**
     * Selects the tab with the given id and shows its associated content panel.
     *
     * Any other tab that was previously selected becomes unselected and its associated pane is removed from DOM or
     * hidden depending on the `destroyOnHide` value.
     * @param {?} tabId
     * @return {?}
     */
    select(tabId) {
        /** @type {?} */
        let selectedTab = this._getTabById(tabId);
        if (selectedTab && !selectedTab.disabled && this.activeId !== selectedTab.id) {
            /** @type {?} */
            let defaultPrevented = false;
            this.tabChange.emit({ activeId: this.activeId, nextId: selectedTab.id, preventDefault: () => { defaultPrevented = true; } });
            if (!defaultPrevented) {
                this.activeId = selectedTab.id;
            }
        }
    }
    /**
     * @return {?}
     */
    ngAfterContentChecked() {
        // auto-correct activeId that might have been set incorrectly as input
        /** @type {?} */
        let activeTab = this._getTabById(this.activeId);
        this.activeId = activeTab ? activeTab.id : (this.tabs.length ? this.tabs.first.id : null);
    }
    /**
     * @param {?} id
     * @return {?}
     */
    _getTabById(id) {
        /** @type {?} */
        let tabsWithId = this.tabs.filter(tab => tab.id === id);
        return tabsWithId.length ? tabsWithId[0] : null;
    }
}
Tabset.decorators = [
    { type: Component, args: [{
                selector: 'tabset',
                exportAs: 'tabset',
                template: `
    <ul [class]="'nav nav-' + type + (orientation == 'horizontal'?  ' ' + justifyClass : ' flex-column')" role="tablist">
      <li class="nav-item" *ngFor="let tab of tabs">
        <a [id]="tab.id" class="nav-link" [class.active]="tab.id === activeId" [class.disabled]="tab.disabled"
          href (click)="select(tab.id); $event.preventDefault()" role="tab" [attr.tabindex]="(tab.disabled ? '-1': undefined)"
          [attr.aria-controls]="(!destroyOnHide || tab.id === activeId ? tab.id + '-panel' : null)"
          [attr.aria-selected]="tab.id === activeId" [attr.aria-disabled]="tab.disabled">
          {{tab.title}}<ng-template [ngTemplateOutlet]="tab.titleTpl?.templateRef"></ng-template>
        </a>
      </li>
    </ul>
    <div class="tab-content">
      <ng-template ngFor let-tab [ngForOf]="tabs">
        <div
          class="tab-pane {{tab.id === activeId ? 'active' : null}}"
          *ngIf="!destroyOnHide || tab.id === activeId"
          role="tabpanel"
          [attr.aria-labelledby]="tab.id" id="{{tab.id}}-panel">
          <ng-template [ngTemplateOutlet]="tab.contentTpl?.templateRef"></ng-template>
        </div>
      </ng-template>
    </div>
  `
            }] }
];
/** @nocollapse */
Tabset.ctorParameters = () => [
    { type: TabsetConfig }
];
Tabset.propDecorators = {
    tabs: [{ type: ContentChildren, args: [Tab,] }],
    activeId: [{ type: Input }],
    destroyOnHide: [{ type: Input }],
    justify: [{ type: Input }],
    orientation: [{ type: Input }],
    type: [{ type: Input }],
    tabChange: [{ type: Output }]
};

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,uselessCode} checked by tsc
 */
/** @type {?} */
const TABSET_DIRECTIVES = [Tabset, Tab, TabContent, TabTitle];
class TabsetModule {
    /**
     * Importing with '.forRoot()' is no longer necessary, you can simply import the module.
     * Will be removed in 4.0.0.
     *
     * @deprecated 3.0.0
     * @return {?}
     */
    static forRoot() { return { ngModule: TabsetModule }; }
}
TabsetModule.decorators = [
    { type: NgModule, args: [{ declarations: TABSET_DIRECTIVES, exports: TABSET_DIRECTIVES, imports: [CommonModule] },] }
];

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,uselessCode} checked by tsc
 */
class AlertComponent {
    constructor() {
        this.alertStyle = 'primary';
    }
    /**
     * @return {?}
     */
    ngOnInit() {
    }
}
AlertComponent.decorators = [
    { type: Component, args: [{
                selector: 'pl-alert',
                template: "<div\n  class=\"alert\"\n  [ngClass]=\"'alert-' + alertStyle\"\n>\n  <ng-content></ng-content>\n</div>\n",
                styles: [""]
            }] }
];
/** @nocollapse */
AlertComponent.ctorParameters = () => [];
AlertComponent.propDecorators = {
    alertStyle: [{ type: Input, args: ['alert-style',] }]
};

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,uselessCode} checked by tsc
 */
class ModalModule {
}
ModalModule.decorators = [
    { type: NgModule, args: [{
                declarations: [
                    NgbModalBackdrop,
                    NgbModalWindow,
                    ModalComponent
                ],
                entryComponents: [
                    NgbModalBackdrop,
                    NgbModalWindow
                ],
                exports: [
                    ModalComponent
                ],
                providers: [NgbModal]
            },] }
];

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,uselessCode} checked by tsc
 */
class InputTextComponent {
    /**
     * @param {?} injector
     */
    constructor(injector) {
        this.injector = injector;
        this.appendClass = 'primary';
        this.class = '';
        this.disabled = false;
        this.formType = 'group';
        this.iconSize = '1x';
        this.margin = true;
        this.maskText = '';
        this.placeholder = '';
        this.prependClass = 'primary';
        this.readonly = false;
        this.showValue = false;
        this.showValidation = true;
        this.tooltipPosition = 'auto';
        this.type = 'text';
        this.uppercase = false;
        this.appendClick = new EventEmitter();
        this.prependClick = new EventEmitter();
    }
    /**
     * @return {?}
     */
    ngOnInit() {
        try {
            this.ngControl = this.injector.get(NgControl);
            this._formControl = this.ngControl;
        }
        catch (e) {
            console.log(e);
        }
    }
    /**
     * @return {?}
     */
    change() {
        if (this.onChange)
            this.onChange(this.model);
    }
    /**
     * @param {?} fn
     * @return {?}
     */
    registerOnChange(fn) {
        this.onChange = fn;
    }
    /**
     * @param {?} fn
     * @return {?}
     */
    registerOnTouched(fn) {
        this.onTouched = fn;
    }
    /**
     * @param {?} isDisabled
     * @return {?}
     */
    setDisabledState(isDisabled) {
        this._disabled = isDisabled;
        this.disabled = isDisabled;
    }
    /**
     * @param {?} obj
     * @return {?}
     */
    writeValue(obj) {
        this.model = obj;
    }
    /**
     * @param {?} event
     * @return {?}
     */
    appendClicked(event) {
        if (!event)
            return;
        event.preventDefault();
        event.stopPropagation();
        if (this.appendClick) {
            this.appendClick.emit();
        }
    }
    /**
     * @param {?} event
     * @return {?}
     */
    prependClicked(event) {
        if (!event)
            return;
        event.preventDefault();
        event.stopPropagation();
        if (this.prependClick) {
            this.prependClick.emit();
        }
    }
}
InputTextComponent.decorators = [
    { type: Component, args: [{
                selector: 'pf-input-text',
                template: "<div\r\n  [ngClass]=\"'form-'+formType\"\r\n  [class.mb-0]=\"!margin\"\r\n  [tooltip]=\"tooltip\"\r\n  [tooltipClass]=\"tooltipClass\"\r\n  [placement]=\"tooltipPosition\"\r\n>\r\n  <label\r\n    *ngIf=\"label\"\r\n  >\r\n    {{label}}\r\n  </label>\r\n\r\n  <div class=\"input-group\">\r\n    <div class=\"input-group-prepend\" *ngIf=\"prepend || prependIcon\">\r\n      <button\r\n        [ngClass]=\"['btn', prependClass ]\"\r\n        type=\"button\"\r\n        (click)=\"prependClicked($event)\"\r\n      >\r\n        <fa-icon\r\n          [icon]=\"prependIcon\"\r\n          *ngIf=\"prependIcon\"\r\n          [size]=\"iconSize\"\r\n          [fixedWidth]=\"true\"\r\n        ></fa-icon>\r\n        {{prepend}}\r\n      </button>\r\n    </div>\r\n    <input\r\n      [(ngModel)]=\"model\"\r\n      [ngClass]=\"['form-control', class]\"\r\n      (ngModelChange)=\"change()\"\r\n      [placeholder]=\"placeholder\"\r\n      *ngIf=\"!rows\"\r\n      [readOnly]=\"readonly\"\r\n      [disabled]=\"disabled\"\r\n      [type]=\"type\"\r\n      (blur)=\"onTouched ? onTouched(): ''\"\r\n      [class.is-invalid]=\"_formControl && !disabled ? !_formControl.valid : null\"\r\n      [class.uppercase]=\"uppercase\"\r\n      [autocomplete]=\"autoComplete\"\r\n    />\r\n    <textarea\r\n      [(ngModel)]=\"model\"\r\n      class=\"form-control\"\r\n      (ngModelChange)=\"change()\"\r\n      [placeholder]=\"placeholder\"\r\n      *ngIf=\"rows\"\r\n      [disabled]=\"disabled\"\r\n      [rows]=\"rows\"\r\n      [class.is-invalid]=\"_formControl && !disabled ? !_formControl.valid : false\"\r\n    ></textarea>\r\n    <div\r\n      class=\"input-group-append\"\r\n      *ngIf=\"append || appendIcon\"\r\n    >\r\n      <pl-button\r\n        [btn-style]=\"appendClass\"\r\n        (click)=\"appendClicked($event)\"\r\n        [tooltip]=\"appendTooltip\"\r\n      >\r\n        <icon\r\n          *ngIf=\"appendIcon\"\r\n          [icon]=\"appendIcon\"\r\n          [fixedWidth]=\"true\"\r\n        ></icon>\r\n        {{append}}\r\n      </pl-button>\r\n    </div>\r\n    <div class=\"invalid-feedback\" *ngIf=\"_formControl ? !_formControl.valid : false\">\r\n      <pf-field-error [form-control]=\"_formControl\"></pf-field-error>\r\n    </div>\r\n  </div>\r\n  <div *ngIf=\"showValue\">{{ model }}</div>\r\n</div>\r\n",
                providers: [{
                        provide: NG_VALUE_ACCESSOR,
                        useExisting: forwardRef(() => InputTextComponent),
                        multi: true
                    }],
                styles: [""]
            }] }
];
/** @nocollapse */
InputTextComponent.ctorParameters = () => [
    { type: Injector }
];
InputTextComponent.propDecorators = {
    append: [{ type: Input }],
    appendIcon: [{ type: Input, args: ['append-icon',] }],
    appendClass: [{ type: Input, args: ['append-class',] }],
    appendTooltip: [{ type: Input, args: ['append-tooltip',] }],
    autoComplete: [{ type: Input }],
    class: [{ type: Input }],
    disabled: [{ type: Input }],
    formType: [{ type: Input, args: ['form-type',] }],
    formControl: [{ type: Input }],
    iconSize: [{ type: Input }],
    label: [{ type: Input }],
    margin: [{ type: Input }],
    maskText: [{ type: Input }],
    placeholder: [{ type: Input }],
    prepend: [{ type: Input }],
    prependClass: [{ type: Input, args: ['prepend-class',] }],
    prependIcon: [{ type: Input, args: ['prepend-icon',] }],
    prependIconSmall: [{ type: Input }],
    readonly: [{ type: Input }],
    rows: [{ type: Input }],
    showValue: [{ type: Input }],
    showValidation: [{ type: Input }],
    text: [{ type: Input }],
    tooltip: [{ type: Input }],
    tooltipClass: [{ type: Input, args: ['tooltip-class',] }],
    tooltipPosition: [{ type: Input, args: ['tooltip-position',] }],
    type: [{ type: Input }],
    uppercase: [{ type: Input }],
    appendClick: [{ type: Output }],
    prependClick: [{ type: Output }]
};

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,uselessCode} checked by tsc
 */
class InputSelectComponent extends InputTextComponent {
    /**
     * @param {?} injector
     */
    constructor(injector) {
        super(injector);
        this.injector = injector;
        this.formType = 'group';
    }
    /**
     * @return {?}
     */
    ngOnInit() {
        super.ngOnInit();
    }
    /**
     * @return {?}
     */
    clearSelection() {
        this.model = null;
        this.change();
    }
}
InputSelectComponent.decorators = [
    { type: Component, args: [{
                selector: 'pf-input-select',
                template: "<div\r\n  [class.m-0]=\"noGutters\"\r\n  [ngClass]=\"'form-'+formType\"\r\n>\r\n\r\n  <label\r\n    *ngIf=\"label\"\r\n    [class.mr-2]=\"formType === 'inline'\"\r\n  >\r\n    {{label}}\r\n  </label>\r\n\r\n  <div class=\"input-group\">\r\n\r\n    <div class=\"input-group-prepend\" *ngIf=\"prepend || prependIcon\">\r\n\r\n      <pl-button\r\n        [btn-style]=\"prependClass\"\r\n        (click)=\"prependClicked($event)\"\r\n      >\r\n        <icon\r\n          [icon]=\"prependIcon\"\r\n          *ngIf=\"prependIcon\"\r\n          [size]=\"iconSize\"\r\n          [fixedWidth]=\"true\"\r\n        ></icon>\r\n        {{prepend}}\r\n      </pl-button>\r\n\r\n    </div>\r\n\r\n    <select\r\n      #inputSelect\r\n      class=\"custom-select\"\r\n      [(ngModel)]=\"model\"\r\n      (ngModelChange)=\"change()\"\r\n      [disabled]=\"disabled\"\r\n      (blur)=\"onTouched ? onTouched(): ''\"\r\n      [class.is-invalid]=\"_formControl?!_formControl.valid && _formControl.touched:null\"\r\n    >\r\n\r\n      <option value=\"\" *ngIf=\"defaultText\">{{defaultText}}</option>\r\n\r\n      <ng-container *ngIf=\"valueProp\">\r\n        <option\r\n          *ngFor=\"let item of list\"\r\n          [value]=\"item[valueProp]\"\r\n        >{{ item[displayProp]}}</option>\r\n      </ng-container>\r\n\r\n      <ng-container *ngIf=\"!valueProp\">\r\n        <option\r\n          *ngFor=\"let item of list\"\r\n          [value]=\"item\"\r\n        >{{ item }}</option>\r\n      </ng-container>\r\n\r\n    </select>\r\n\r\n    <div\r\n      *ngIf=\"clear\"\r\n      class=\"input-group-append\"\r\n    >\r\n      <pl-button\r\n        btn-style=\"outline-danger\"\r\n        icon=\"ban\"\r\n        tooltip=\"Limpar\"\r\n        tooltip-class=\"danger\"\r\n        (click)=\"clearSelection()\"\r\n      ></pl-button>\r\n    </div>\r\n    <div\r\n      class=\"input-group-append\"\r\n      *ngIf=\"append || appendIcon\"\r\n    >\r\n      <pl-button\r\n        [btn-style]=\"appendClass\"\r\n        (click)=\"appendClicked($event)\"\r\n      >\r\n        <icon\r\n          [icon]=\"appendIcon\"\r\n          *ngIf=\"appendIcon\"\r\n          [size]=\"iconSize\"\r\n        ></icon>\r\n        {{append}}\r\n      </pl-button>\r\n    </div>\r\n    <div class=\"invalid-feedback\">\r\n      <pf-field-error [form-control]=\"_formControl\"></pf-field-error>\r\n    </div>\r\n  </div>\r\n  <span *ngIf=\"showValue\">{{model}}</span>\r\n</div>\r\n",
                providers: [{
                        provide: NG_VALUE_ACCESSOR,
                        useExisting: forwardRef(() => InputSelectComponent),
                        multi: true
                    }],
                styles: [".custom-select:hover{cursor:pointer}"]
            }] }
];
/** @nocollapse */
InputSelectComponent.ctorParameters = () => [
    { type: Injector }
];
InputSelectComponent.propDecorators = {
    inputRef: [{ type: ViewChild, args: ['inputSelect',] }],
    list: [{ type: Input }],
    clear: [{ type: Input }],
    defaultText: [{ type: Input, args: ['default-text',] }],
    noGutters: [{ type: Input, args: ['no-gutters',] }],
    displayProp: [{ type: Input, args: ['prop-text',] }],
    valueProp: [{ type: Input, args: ['prop-value',] }],
    formType: [{ type: Input, args: ['form-type',] }]
};

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,uselessCode} checked by tsc
 */
class FieldErrorService {
    constructor() { }
    /**
     * @param {?} formControl
     * @return {?}
     */
    getErrorMessage(formControl) {
        if (!formControl.errors) {
            return null;
        }
        if (formControl.errors.pattern) {
            return 'Formato inválido!';
        }
        if (formControl.errors.required) {
            return 'Campo Obrigatório';
        }
        if (formControl.errors.email) {
            return 'Formato de e-mail inválido';
        }
        if (formControl.errors.minlength) {
            /** @type {?} */
            const requiredLength = formControl.errors.minlength.requiredLength;
            return `Deve ter no mínimo ${requiredLength} caracteres`;
        }
        if (formControl.errors.notSame) {
            return `Campos não são idênticos.`;
        }
        if (formControl.errors.maxlength) {
            /** @type {?} */
            const requiredLength = formControl.errors.maxlength.requiredLength;
            return `Deve ter no máximo ${requiredLength} caracteres`;
        }
        if (formControl.errors.reservedWord) {
            return 'Essa palavra é reservada, não é possível utilizá-la';
        }
    }
}
FieldErrorService.decorators = [
    { type: Injectable, args: [{
                providedIn: 'root'
            },] }
];
/** @nocollapse */
FieldErrorService.ctorParameters = () => [];
/** @nocollapse */ FieldErrorService.ngInjectableDef = defineInjectable({ factory: function FieldErrorService_Factory() { return new FieldErrorService(); }, token: FieldErrorService, providedIn: "root" });

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,uselessCode} checked by tsc
 */
class FieldErrorComponent {
    /**
     * @param {?} fieldErrorService
     */
    constructor(fieldErrorService) {
        this.fieldErrorService = fieldErrorService;
    }
    /**
     * @return {?}
     */
    ngOnInit() {
        this.formControl = this.formControlPassed;
    }
    /**
     * @param {?} formControl
     * @return {?}
     */
    findFormControl(formControl) {
        if (this.formControlPassed.validator == null) {
            Object.keys(this.formControlPassed.controls).forEach(name => {
                if (this.formControlPassed.controls[name].validator != null) {
                    return this.formControlPassed.controls[name];
                }
            });
        }
        else {
            return formControl;
        }
    }
    /**
     * @return {?}
     */
    get errorMessage() {
        if (this.mustShowErrorMessage()) {
            return this.fieldErrorService.getErrorMessage(this.formControl);
        }
        else {
            return null;
        }
    }
    /**
     * @return {?}
     */
    mustShowErrorMessage() {
        if (!this.formControl) {
            return false;
        }
        return this.formControl.invalid;
    }
    /**
     * @return {?}
     */
    getErrorMessage() {
        console.log(this.formControl.errors);
        if (this.formControl.errors.pattern) {
            return 'Formato inválido!';
        }
        if (this.formControl.errors.required) {
            return 'Campo Obrigatório';
        }
        if (this.formControl.errors.email) {
            return 'Formato de e-mail inválido';
        }
        if (this.formControl.errors.minlength) {
            /** @type {?} */
            const requiredLength = this.formControl.errors.minlength.requiredLength;
            return `Deve ter no mínimo ${requiredLength} caracteres`;
        }
        if (this.formControl.errors.notSame) {
            return `Campos não são idênticos.`;
        }
        if (this.formControl.errors.maxlength) {
            /** @type {?} */
            const requiredLength = this.formControl.errors.maxlength.requiredLength;
            return `Deve ter no máximo ${requiredLength} caracteres`;
        }
    }
}
FieldErrorComponent.decorators = [
    { type: Component, args: [{
                selector: 'pf-field-error',
                template: "{{ errorMessage }}\r\n",
                styles: [""]
            }] }
];
/** @nocollapse */
FieldErrorComponent.ctorParameters = () => [
    { type: FieldErrorService }
];
FieldErrorComponent.propDecorators = {
    formControlPassed: [{ type: Input, args: ['form-control',] }]
};

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,uselessCode} checked by tsc
 */
class ToastEventService {
    constructor() {
        this.toastAdded = new EventEmitter();
    }
}
ToastEventService.decorators = [
    { type: Injectable, args: [{
                providedIn: 'root'
            },] }
];
/** @nocollapse */
ToastEventService.ctorParameters = () => [];
/** @nocollapse */ ToastEventService.ngInjectableDef = defineInjectable({ factory: function ToastEventService_Factory() { return new ToastEventService(); }, token: ToastEventService, providedIn: "root" });

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,uselessCode} checked by tsc
 */
class ToastComponent {
    /**
     * @param {?} toastService
     */
    constructor(toastService) {
        this.toastService = toastService;
        this.toasts = [];
        this.toastService.toastAdded.subscribe(toast => {
            toast.id = this.toasts.length + 1;
            toast.date = new Date();
            this.toasts.push(toast);
            toast.showing = true;
            if (toast.options.autoClose) {
                setTimeout(() => {
                    if (toast.showing)
                        this.hideToast(toast);
                }, 3000);
            }
            toast.interval = setInterval(() => {
                if (toast.showing) {
                    toast.timeOpened = new Date().getTime() - toast.date.getTime();
                }
                else {
                    clearInterval(toast.interval);
                }
            }, 10000);
        });
    }
    /**
     * @return {?}
     */
    ngOnInit() {
    }
    /**
     * @param {?} toast
     * @return {?}
     */
    hideToast(toast) {
        toast.showing = false;
        /** @type {?} */
        const index = this.toasts.findIndex(t => t.id === toast.id);
        if (index >= 0) {
            setTimeout(() => {
                this.toasts.splice(index, 1);
            }, 500);
        }
    }
}
ToastComponent.decorators = [
    { type: Component, args: [{
                selector: 'pl-toast',
                template: "<div class=\"toast-wrapper\">\n\n  <div\n    *ngFor=\"let toast of toasts\"\n    class=\"toast\"\n    [class.showing]=\"toast.showing\"\n    [class.bg-success]=\"toast.type === 'success'\"\n    [class.bg-danger]=\"toast.type === 'error'\"\n    role=\"alert\"\n    aria-live=\"assertive\"\n    aria-atomic=\"true\"\n    (click)=\"hideToast(toast)\"\n  >\n    <div\n      class=\"toast-header py-2\"\n      *ngIf=\"toast.title\"\n    >\n      <fa-icon\n        *ngIf=\"toast.type === 'success'\"\n        icon=\"check\"\n        class=\"mr-2\"\n      ></fa-icon>\n      <fa-icon\n        *ngIf=\"toast.type === 'error'\"\n        icon=\"exclamation-triangle\"\n        class=\"mr-2\"\n      ></fa-icon>\n      <strong class=\"mr-auto\">{{toast.title}}</strong>\n      <small class=\"text-muted\">\n        <span *ngIf=\"!toast.timeOpened\">agora</span>\n        <span>{{toast.timeOpened | date:'mm:ss'}}</span>\n        <fa-icon icon=\"clock\"></fa-icon>\n      </small>\n\n    </div>\n\n    <div class=\"toast-body\" [innerHtml]=\"toast.message\">\n    </div>\n\n  </div>\n\n</div>\n",
                styles: [".toast-wrapper{position:fixed;top:0;left:0;padding-left:1rem;padding-top:1rem;z-index:999999}.toast-wrapper .toast{position:-webkit-sticky;position:sticky;width:auto;max-width:100vw;transition:opacity .3s linear}.toast-wrapper .toast.bg-danger,.toast-wrapper .toast.bg-success{color:#fff}"]
            }] }
];
/** @nocollapse */
ToastComponent.ctorParameters = () => [
    { type: ToastEventService }
];

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,uselessCode} checked by tsc
 */
/**
 * Everything a toast needs to launch
 */
class ToastPackage {
    /**
     * @param {?} toastId
     * @param {?} config
     * @param {?} message
     * @param {?} title
     * @param {?} toastType
     * @param {?} toastRef
     */
    constructor(toastId, config, message, title, toastType, toastRef) {
        this.toastId = toastId;
        this.config = config;
        this.message = message;
        this.title = title;
        this.toastType = toastType;
        this.toastRef = toastRef;
        this._onTap = new Subject();
        this._onAction = new Subject();
        this.toastRef.afterClosed().subscribe(() => {
            this._onAction.complete();
            this._onTap.complete();
        });
    }
    /**
     * Fired on click
     * @return {?}
     */
    triggerTap() {
        this._onTap.next();
        if (this.config.tapToDismiss) {
            this._onTap.complete();
        }
    }
    /**
     * @return {?}
     */
    onTap() {
        return this._onTap.asObservable();
    }
    /**
     * available for use in custom toast
     * @param {?=} action
     * @return {?}
     */
    triggerAction(action) {
        this._onAction.next(action);
    }
    /**
     * @return {?}
     */
    onAction() {
        return this._onAction.asObservable();
    }
}
/** @type {?} */
const DefaultNoComponentGlobalConfig = {
    maxOpened: 0,
    autoDismiss: false,
    newestOnTop: true,
    preventDuplicates: false,
    countDuplicates: false,
    resetTimeoutOnDuplicate: false,
    iconClasses: {
        error: 'toast-error',
        info: 'toast-info',
        success: 'toast-success',
        warning: 'toast-warning',
    },
    // Individual
    closeButton: false,
    disableTimeOut: false,
    timeOut: 5000,
    extendedTimeOut: 1000,
    enableHtml: false,
    progressBar: false,
    toastClass: 'ngx-toastr',
    positionClass: 'toast-top-right',
    titleClass: 'toast-title',
    messageClass: 'toast-message',
    easing: 'ease-in',
    easeTime: 300,
    tapToDismiss: true,
    onActivateTick: false,
    progressAnimation: 'decreasing',
};
/** @type {?} */
const TOAST_CONFIG = new InjectionToken('ToastConfig');

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,uselessCode} checked by tsc
 */
/**
 * A `ComponentPortal` is a portal that instantiates some Component upon attachment.
 * @template T
 */
class ComponentPortal {
    /**
     * @param {?} component
     * @param {?} injector
     */
    constructor(component, injector) {
        this.component = component;
        this.injector = injector;
    }
    /**
     * Attach this portal to a host.
     * @param {?} host
     * @param {?} newestOnTop
     * @return {?}
     */
    attach(host, newestOnTop) {
        this._attachedHost = host;
        return host.attach(this, newestOnTop);
    }
    /**
     * Detach this portal from its host
     * @return {?}
     */
    detach() {
        /** @type {?} */
        const host = this._attachedHost;
        if (host) {
            this._attachedHost = undefined;
            return host.detach();
        }
    }
    /**
     * Whether this portal is attached to a host.
     * @return {?}
     */
    get isAttached() {
        return this._attachedHost != null;
    }
    /**
     * Sets the PortalHost reference without performing `attach()`. This is used directly by
     * the PortalHost when it is performing an `attach()` or `detach()`.
     * @param {?=} host
     * @return {?}
     */
    setAttachedHost(host) {
        this._attachedHost = host;
    }
}
/**
 * Partial implementation of PortalHost that only deals with attaching a
 * ComponentPortal
 * @abstract
 */
class BasePortalHost {
    /**
     * @param {?} portal
     * @param {?} newestOnTop
     * @return {?}
     */
    attach(portal, newestOnTop) {
        this._attachedPortal = portal;
        return this.attachComponentPortal(portal, newestOnTop);
    }
    /**
     * @return {?}
     */
    detach() {
        if (this._attachedPortal) {
            this._attachedPortal.setAttachedHost();
        }
        this._attachedPortal = undefined;
        if (this._disposeFn) {
            this._disposeFn();
            this._disposeFn = undefined;
        }
    }
    /**
     * @param {?} fn
     * @return {?}
     */
    setDisposeFn(fn) {
        this._disposeFn = fn;
    }
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,uselessCode} checked by tsc
 */
/**
 * A PortalHost for attaching portals to an arbitrary DOM element outside of the Angular
 * application context.
 *
 * This is the only part of the portal core that directly touches the DOM.
 */
class DomPortalHost extends BasePortalHost {
    /**
     * @param {?} _hostDomElement
     * @param {?} _componentFactoryResolver
     * @param {?} _appRef
     */
    constructor(_hostDomElement, _componentFactoryResolver, _appRef) {
        super();
        this._hostDomElement = _hostDomElement;
        this._componentFactoryResolver = _componentFactoryResolver;
        this._appRef = _appRef;
    }
    /**
     * Attach the given ComponentPortal to DOM element using the ComponentFactoryResolver.
     * @template T
     * @param {?} portal Portal to be attached
     * @param {?} newestOnTop
     * @return {?}
     */
    attachComponentPortal(portal, newestOnTop) {
        /** @type {?} */
        const componentFactory = this._componentFactoryResolver.resolveComponentFactory(portal.component);
        /** @type {?} */
        let componentRef;
        // If the portal specifies a ViewContainerRef, we will use that as the attachment point
        // for the component (in terms of Angular's component tree, not rendering).
        // When the ViewContainerRef is missing, we use the factory to create the component directly
        // and then manually attach the ChangeDetector for that component to the application (which
        // happens automatically when using a ViewContainer).
        componentRef = componentFactory.create(portal.injector);
        // When creating a component outside of a ViewContainer, we need to manually register
        // its ChangeDetector with the application. This API is unfortunately not yet published
        // in Angular core. The change detector must also be deregistered when the component
        // is destroyed to prevent memory leaks.
        this._appRef.attachView(componentRef.hostView);
        this.setDisposeFn(() => {
            this._appRef.detachView(componentRef.hostView);
            componentRef.destroy();
        });
        // At this point the component has been instantiated, so we move it to the location in the DOM
        // where we want it to be rendered.
        if (newestOnTop) {
            this._hostDomElement.insertBefore(this._getComponentRootNode(componentRef), this._hostDomElement.firstChild);
        }
        else {
            this._hostDomElement.appendChild(this._getComponentRootNode(componentRef));
        }
        return componentRef;
    }
    /**
     * Gets the root HTMLElement for an instantiated component.
     * @param {?} componentRef
     * @return {?}
     */
    _getComponentRootNode(componentRef) {
        return (/** @type {?} */ (((/** @type {?} */ (componentRef.hostView))).rootNodes[0]));
    }
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,uselessCode} checked by tsc
 */
/**
 * Container inside which all toasts will render.
 */
class OverlayContainer {
    /**
     * @param {?} _document
     */
    constructor(_document) {
        this._document = _document;
    }
    /**
     * @return {?}
     */
    ngOnDestroy() {
        if (this._containerElement && this._containerElement.parentNode) {
            this._containerElement.parentNode.removeChild(this._containerElement);
        }
    }
    /**
     * This method returns the overlay container element. It will lazily
     * create the element the first time  it is called to facilitate using
     * the container in non-browser environments.
     * @return {?} the container element
     */
    getContainerElement() {
        if (!this._containerElement) {
            this._createContainer();
        }
        return this._containerElement;
    }
    /**
     * Create the overlay container element, which is simply a div
     * with the 'cdk-overlay-container' class on the document body.
     * @return {?}
     */
    _createContainer() {
        /** @type {?} */
        const container = this._document.createElement('div');
        container.classList.add('overlay-container');
        this._document.body.appendChild(container);
        this._containerElement = container;
    }
}
OverlayContainer.decorators = [
    { type: Injectable, args: [{ providedIn: 'root' },] }
];
/** @nocollapse */
OverlayContainer.ctorParameters = () => [
    { type: undefined, decorators: [{ type: Inject, args: [DOCUMENT,] }] }
];
/** @nocollapse */ OverlayContainer.ngInjectableDef = defineInjectable({ factory: function OverlayContainer_Factory() { return new OverlayContainer(inject(DOCUMENT)); }, token: OverlayContainer, providedIn: "root" });

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,uselessCode} checked by tsc
 */
/**
 * Reference to an overlay that has been created with the Overlay service.
 * Used to manipulate or dispose of said overlay.
 */
class OverlayRef {
    /**
     * @param {?} _portalHost
     */
    constructor(_portalHost) {
        this._portalHost = _portalHost;
    }
    /**
     * @param {?} portal
     * @param {?=} newestOnTop
     * @return {?}
     */
    attach(portal, newestOnTop = true) {
        return this._portalHost.attach(portal, newestOnTop);
    }
    /**
     * Detaches an overlay from a portal.
     * @return {?} Resolves when the overlay has been detached.
     */
    detach() {
        return this._portalHost.detach();
    }
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,uselessCode} checked by tsc
 */
/**
 * Service to create Overlays. Overlays are dynamically added pieces of floating UI, meant to be
 * used as a low-level building building block for other components. Dialogs, tooltips, menus,
 * selects, etc. can all be built using overlays. The service should primarily be used by authors
 * of re-usable components rather than developers building end-user applications.
 *
 * An overlay *is* a PortalHost, so any kind of Portal can be loaded into one.
 */
class Overlay {
    /**
     * @param {?} _overlayContainer
     * @param {?} _componentFactoryResolver
     * @param {?} _appRef
     * @param {?} _document
     */
    constructor(_overlayContainer, _componentFactoryResolver, _appRef, _document) {
        this._overlayContainer = _overlayContainer;
        this._componentFactoryResolver = _componentFactoryResolver;
        this._appRef = _appRef;
        this._document = _document;
        // Namespace panes by overlay container
        this._paneElements = new Map();
    }
    /**
     * Creates an overlay.
     * @param {?=} positionClass
     * @param {?=} overlayContainer
     * @return {?} A reference to the created overlay.
     */
    create(positionClass, overlayContainer) {
        // get existing pane if possible
        return this._createOverlayRef(this.getPaneElement(positionClass, overlayContainer));
    }
    /**
     * @param {?=} positionClass
     * @param {?=} overlayContainer
     * @return {?}
     */
    getPaneElement(positionClass = '', overlayContainer) {
        if (!this._paneElements.get(overlayContainer)) {
            this._paneElements.set(overlayContainer, {});
        }
        if (!this._paneElements.get(overlayContainer)[positionClass]) {
            this._paneElements.get(overlayContainer)[positionClass] = this._createPaneElement(positionClass, overlayContainer);
        }
        return this._paneElements.get(overlayContainer)[positionClass];
    }
    /**
     * Creates the DOM element for an overlay and appends it to the overlay container.
     * @param {?} positionClass
     * @param {?=} overlayContainer
     * @return {?} Newly-created pane element
     */
    _createPaneElement(positionClass, overlayContainer) {
        /** @type {?} */
        const pane = this._document.createElement('div');
        pane.id = 'toast-container';
        pane.classList.add(positionClass);
        pane.classList.add('toast-container');
        if (!overlayContainer) {
            this._overlayContainer.getContainerElement().appendChild(pane);
        }
        else {
            overlayContainer.getContainerElement().appendChild(pane);
        }
        return pane;
    }
    /**
     * Create a DomPortalHost into which the overlay content can be loaded.
     * @param {?} pane The DOM element to turn into a portal host.
     * @return {?} A portal host for the given DOM element.
     */
    _createPortalHost(pane) {
        return new DomPortalHost(pane, this._componentFactoryResolver, this._appRef);
    }
    /**
     * Creates an OverlayRef for an overlay in the given DOM element.
     * @param {?} pane DOM element for the overlay
     * @return {?}
     */
    _createOverlayRef(pane) {
        return new OverlayRef(this._createPortalHost(pane));
    }
}
Overlay.decorators = [
    { type: Injectable, args: [{ providedIn: 'root' },] }
];
/** @nocollapse */
Overlay.ctorParameters = () => [
    { type: OverlayContainer },
    { type: ComponentFactoryResolver },
    { type: ApplicationRef },
    { type: undefined, decorators: [{ type: Inject, args: [DOCUMENT,] }] }
];
/** @nocollapse */ Overlay.ngInjectableDef = defineInjectable({ factory: function Overlay_Factory() { return new Overlay(inject(OverlayContainer), inject(ComponentFactoryResolver), inject(ApplicationRef), inject(DOCUMENT)); }, token: Overlay, providedIn: "root" });

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,uselessCode} checked by tsc
 */
/**
 * Reference to a toast opened via the Toastr service.
 * @template T
 */
class ToastRef {
    /**
     * @param {?} _overlayRef
     */
    constructor(_overlayRef) {
        this._overlayRef = _overlayRef;
        /**
         * Count of duplicates of this toast
         */
        this.duplicatesCount = 0;
        /**
         * Subject for notifying the user that the toast has finished closing.
         */
        this._afterClosed = new Subject();
        /**
         * triggered when toast is activated
         */
        this._activate = new Subject();
        /**
         * notifies the toast that it should close before the timeout
         */
        this._manualClose = new Subject();
        /**
         * notifies the toast that it should reset the timeouts
         */
        this._resetTimeout = new Subject();
        /**
         * notifies the toast that it should count a duplicate toast
         */
        this._countDuplicate = new Subject();
    }
    /**
     * @return {?}
     */
    manualClose() {
        this._manualClose.next();
        this._manualClose.complete();
    }
    /**
     * @return {?}
     */
    manualClosed() {
        return this._manualClose.asObservable();
    }
    /**
     * @return {?}
     */
    timeoutReset() {
        return this._resetTimeout.asObservable();
    }
    /**
     * @return {?}
     */
    countDuplicate() {
        return this._countDuplicate.asObservable();
    }
    /**
     * Close the toast.
     * @return {?}
     */
    close() {
        this._overlayRef.detach();
        this._afterClosed.next();
        this._manualClose.next();
        this._afterClosed.complete();
        this._manualClose.complete();
        this._activate.complete();
        this._resetTimeout.complete();
        this._countDuplicate.complete();
    }
    /**
     * Gets an observable that is notified when the toast is finished closing.
     * @return {?}
     */
    afterClosed() {
        return this._afterClosed.asObservable();
    }
    /**
     * @return {?}
     */
    isInactive() {
        return this._activate.isStopped;
    }
    /**
     * @return {?}
     */
    activate() {
        this._activate.next();
        this._activate.complete();
    }
    /**
     * Gets an observable that is notified when the toast has started opening.
     * @return {?}
     */
    afterActivate() {
        return this._activate.asObservable();
    }
    /**
     * Reset the toast timouts and count duplicates
     * @param {?} resetTimeout
     * @param {?} countDuplicate
     * @return {?}
     */
    onDuplicate(resetTimeout, countDuplicate) {
        if (resetTimeout) {
            this._resetTimeout.next();
        }
        if (countDuplicate) {
            this._countDuplicate.next(++this.duplicatesCount);
        }
    }
}
/**
 * Custom injector type specifically for instantiating components with a toast.
 */
class ToastInjector {
    /**
     * @param {?} _toastPackage
     * @param {?} _parentInjector
     */
    constructor(_toastPackage, _parentInjector) {
        this._toastPackage = _toastPackage;
        this._parentInjector = _parentInjector;
    }
    /**
     * @template T
     * @param {?} token
     * @param {?=} notFoundValue
     * @param {?=} flags
     * @return {?}
     */
    get(token, notFoundValue, flags) {
        if (token === ToastPackage) {
            return this._toastPackage;
        }
        return this._parentInjector.get(token, notFoundValue, flags);
    }
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,uselessCode} checked by tsc
 */
class ToastrService {
    /**
     * @param {?} token
     * @param {?} overlay
     * @param {?} _injector
     * @param {?} sanitizer
     * @param {?} ngZone
     */
    constructor(token, overlay, _injector, sanitizer, ngZone) {
        this.overlay = overlay;
        this._injector = _injector;
        this.sanitizer = sanitizer;
        this.ngZone = ngZone;
        this.currentlyActive = 0;
        this.toasts = [];
        this.index = 0;
        this.toastrConfig = Object.assign({}, token.default, token.config);
        if (token.config.iconClasses) {
            this.toastrConfig.iconClasses = Object.assign({}, token.default.iconClasses, token.config.iconClasses);
        }
    }
    /**
     * show toast
     * @param {?=} message
     * @param {?=} title
     * @param {?=} override
     * @param {?=} type
     * @return {?}
     */
    show(message, title, override = {}, type = '') {
        return this._preBuildNotification(type, message, title, this.applyConfig(override));
    }
    /**
     * show successful toast
     * @param {?=} message
     * @param {?=} title
     * @param {?=} override
     * @return {?}
     */
    success(message, title, override = {}) {
        /** @type {?} */
        const type = this.toastrConfig.iconClasses.success || '';
        return this._preBuildNotification(type, message, title, this.applyConfig(override));
    }
    /**
     * show error toast
     * @param {?=} message
     * @param {?=} title
     * @param {?=} override
     * @return {?}
     */
    error(message, title, override = {}) {
        /** @type {?} */
        const type = this.toastrConfig.iconClasses.error || '';
        return this._preBuildNotification(type, message, title, this.applyConfig(override));
    }
    /**
     * show info toast
     * @param {?=} message
     * @param {?=} title
     * @param {?=} override
     * @return {?}
     */
    info(message, title, override = {}) {
        /** @type {?} */
        const type = this.toastrConfig.iconClasses.info || '';
        return this._preBuildNotification(type, message, title, this.applyConfig(override));
    }
    /**
     * show warning toast
     * @param {?=} message
     * @param {?=} title
     * @param {?=} override
     * @return {?}
     */
    warning(message, title, override = {}) {
        /** @type {?} */
        const type = this.toastrConfig.iconClasses.warning || '';
        return this._preBuildNotification(type, message, title, this.applyConfig(override));
    }
    /**
     * Remove all or a single toast by id
     * @param {?=} toastId
     * @return {?}
     */
    clear(toastId) {
        // Call every toastRef manualClose function
        for (const toast of this.toasts) {
            if (toastId !== undefined) {
                if (toast.toastId === toastId) {
                    toast.toastRef.manualClose();
                    return;
                }
            }
            else {
                toast.toastRef.manualClose();
            }
        }
    }
    /**
     * Remove and destroy a single toast by id
     * @param {?} toastId
     * @return {?}
     */
    remove(toastId) {
        /** @type {?} */
        const found = this._findToast(toastId);
        if (!found) {
            return false;
        }
        found.activeToast.toastRef.close();
        this.toasts.splice(found.index, 1);
        this.currentlyActive = this.currentlyActive - 1;
        if (!this.toastrConfig.maxOpened || !this.toasts.length) {
            return false;
        }
        if (this.currentlyActive < this.toastrConfig.maxOpened &&
            this.toasts[this.currentlyActive]) {
            /** @type {?} */
            const p = this.toasts[this.currentlyActive].toastRef;
            if (!p.isInactive()) {
                this.currentlyActive = this.currentlyActive + 1;
                p.activate();
            }
        }
        return true;
    }
    /**
     * Determines if toast message is already shown
     * @param {?} message
     * @param {?} resetOnDuplicate
     * @param {?} countDuplicates
     * @return {?}
     */
    findDuplicate(message, resetOnDuplicate, countDuplicates) {
        for (let i = 0; i < this.toasts.length; i++) {
            /** @type {?} */
            const toast = this.toasts[i];
            if (toast.message === message) {
                toast.toastRef.onDuplicate(resetOnDuplicate, countDuplicates);
                return toast;
            }
        }
        return null;
    }
    /**
     * create a clone of global config and apply individual settings
     * @param {?=} override
     * @return {?}
     */
    applyConfig(override = {}) {
        return Object.assign({}, this.toastrConfig, override);
    }
    /**
     * Find toast object by id
     * @param {?} toastId
     * @return {?}
     */
    _findToast(toastId) {
        for (let i = 0; i < this.toasts.length; i++) {
            if (this.toasts[i].toastId === toastId) {
                return { index: i, activeToast: this.toasts[i] };
            }
        }
        return null;
    }
    /**
     * Determines the need to run inside angular's zone then builds the toast
     * @param {?} toastType
     * @param {?} message
     * @param {?} title
     * @param {?} config
     * @return {?}
     */
    _preBuildNotification(toastType, message, title, config) {
        if (config.onActivateTick) {
            return this.ngZone.run(() => this._buildNotification(toastType, message, title, config));
        }
        return this._buildNotification(toastType, message, title, config);
    }
    /**
     * Creates and attaches toast data to component
     * returns the active toast, or in case preventDuplicates is enabled the original/non-duplicate active toast.
     * @param {?} toastType
     * @param {?} message
     * @param {?} title
     * @param {?} config
     * @return {?}
     */
    _buildNotification(toastType, message, title, config) {
        if (!config.toastComponent) {
            throw new Error('toastComponent required');
        }
        // max opened and auto dismiss = true
        // if timeout = 0 resetting it would result in setting this.hideTime = Date.now(). Hence, we only want to reset timeout if there is
        // a timeout at all
        /** @type {?} */
        const duplicate = this.findDuplicate(message, this.toastrConfig.resetTimeoutOnDuplicate && config.timeOut > 0, this.toastrConfig.countDuplicates);
        if (message && this.toastrConfig.preventDuplicates && duplicate !== null) {
            return duplicate;
        }
        this.previousToastMessage = message;
        /** @type {?} */
        let keepInactive = false;
        if (this.toastrConfig.maxOpened &&
            this.currentlyActive >= this.toastrConfig.maxOpened) {
            keepInactive = true;
            if (this.toastrConfig.autoDismiss) {
                this.clear(this.toasts[0].toastId);
            }
        }
        /** @type {?} */
        const overlayRef = this.overlay.create(config.positionClass, this.overlayContainer);
        this.index = this.index + 1;
        /** @type {?} */
        let sanitizedMessage = message;
        if (message && config.enableHtml) {
            sanitizedMessage = this.sanitizer.sanitize(SecurityContext.HTML, message);
        }
        /** @type {?} */
        const toastRef = new ToastRef(overlayRef);
        /** @type {?} */
        const toastPackage = new ToastPackage(this.index, config, sanitizedMessage, title, toastType, toastRef);
        /** @type {?} */
        const toastInjector = new ToastInjector(toastPackage, this._injector);
        /** @type {?} */
        const component = new ComponentPortal(config.toastComponent, toastInjector);
        /** @type {?} */
        const portal = overlayRef.attach(component, this.toastrConfig.newestOnTop);
        toastRef.componentInstance = ((/** @type {?} */ (portal)))._component;
        /** @type {?} */
        const ins = {
            toastId: this.index,
            message: message || '',
            toastRef,
            onShown: toastRef.afterActivate(),
            onHidden: toastRef.afterClosed(),
            onTap: toastPackage.onTap(),
            onAction: toastPackage.onAction(),
            portal
        };
        if (!keepInactive) {
            setTimeout(() => {
                ins.toastRef.activate();
                this.currentlyActive = this.currentlyActive + 1;
            });
        }
        this.toasts.push(ins);
        return ins;
    }
}
ToastrService.decorators = [
    { type: Injectable, args: [{ providedIn: 'root' },] }
];
/** @nocollapse */
ToastrService.ctorParameters = () => [
    { type: undefined, decorators: [{ type: Inject, args: [TOAST_CONFIG,] }] },
    { type: Overlay },
    { type: Injector },
    { type: DomSanitizer },
    { type: NgZone }
];
/** @nocollapse */ ToastrService.ngInjectableDef = defineInjectable({ factory: function ToastrService_Factory() { return new ToastrService(inject(TOAST_CONFIG), inject(Overlay), inject(INJECTOR), inject(DomSanitizer), inject(NgZone)); }, token: ToastrService, providedIn: "root" });

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,uselessCode} checked by tsc
 */
class Toast {
    /**
     * @param {?} toastrService
     * @param {?} toastPackage
     * @param {?=} ngZone
     */
    constructor(toastrService, toastPackage, ngZone) {
        this.toastrService = toastrService;
        this.toastPackage = toastPackage;
        this.ngZone = ngZone;
        /**
         * width of progress bar
         */
        this.width = -1;
        /**
         * a combination of toast type and options.toastClass
         */
        this.toastClasses = '';
        /**
         * controls animation
         */
        this.state = {
            value: 'inactive',
            params: {
                easeTime: this.toastPackage.config.easeTime,
                easing: 'ease-in'
            }
        };
        this.message = toastPackage.message;
        this.title = toastPackage.title;
        this.options = toastPackage.config;
        this.originalTimeout = toastPackage.config.timeOut;
        this.toastClasses = `${toastPackage.toastType} ${toastPackage.config.toastClass}`;
        this.sub = toastPackage.toastRef.afterActivate().subscribe(() => {
            this.activateToast();
        });
        this.sub1 = toastPackage.toastRef.manualClosed().subscribe(() => {
            this.remove();
        });
        this.sub2 = toastPackage.toastRef.timeoutReset().subscribe(() => {
            this.resetTimeout();
        });
        this.sub3 = toastPackage.toastRef.countDuplicate().subscribe(count => {
            this.duplicatesCount = count;
        });
    }
    /**
     * hides component when waiting to be displayed
     * @return {?}
     */
    get displayStyle() {
        if (this.state.value === 'inactive') {
            return 'none';
        }
    }
    /**
     * @return {?}
     */
    ngOnDestroy() {
        this.sub.unsubscribe();
        this.sub1.unsubscribe();
        this.sub2.unsubscribe();
        this.sub3.unsubscribe();
        clearInterval(this.intervalId);
        clearTimeout(this.timeout);
    }
    /**
     * activates toast and sets timeout
     * @return {?}
     */
    activateToast() {
        this.state = Object.assign({}, this.state, { value: 'active' });
        if (!this.options.disableTimeOut && this.options.timeOut) {
            this.outsideTimeout(() => this.remove(), this.options.timeOut);
            this.hideTime = new Date().getTime() + this.options.timeOut;
            if (this.options.progressBar) {
                this.outsideInterval(() => this.updateProgress(), 10);
            }
        }
    }
    /**
     * updates progress bar width
     * @return {?}
     */
    updateProgress() {
        if (this.width === 0 || this.width === 100 || !this.options.timeOut) {
            return;
        }
        /** @type {?} */
        const now = new Date().getTime();
        /** @type {?} */
        const remaining = this.hideTime - now;
        this.width = (remaining / this.options.timeOut) * 100;
        if (this.options.progressAnimation === 'increasing') {
            this.width = 100 - this.width;
        }
        if (this.width <= 0) {
            this.width = 0;
        }
        if (this.width >= 100) {
            this.width = 100;
        }
    }
    /**
     * @return {?}
     */
    resetTimeout() {
        clearTimeout(this.timeout);
        clearInterval(this.intervalId);
        this.state = Object.assign({}, this.state, { value: 'active' });
        this.outsideTimeout(() => this.remove(), this.originalTimeout);
        this.options.timeOut = this.originalTimeout;
        this.hideTime = new Date().getTime() + (this.options.timeOut || 0);
        this.width = -1;
        if (this.options.progressBar) {
            this.outsideInterval(() => this.updateProgress(), 10);
        }
    }
    /**
     * tells toastrService to remove this toast after animation time
     * @return {?}
     */
    remove() {
        if (this.state.value === 'removed') {
            return;
        }
        clearTimeout(this.timeout);
        this.state = Object.assign({}, this.state, { value: 'removed' });
        this.outsideTimeout(() => this.toastrService.remove(this.toastPackage.toastId), +this.toastPackage.config.easeTime);
    }
    /**
     * @return {?}
     */
    tapToast() {
        if (this.state.value === 'removed') {
            return;
        }
        this.toastPackage.triggerTap();
        if (this.options.tapToDismiss) {
            this.remove();
        }
    }
    /**
     * @return {?}
     */
    stickAround() {
        if (this.state.value === 'removed') {
            return;
        }
        clearTimeout(this.timeout);
        this.options.timeOut = 0;
        this.hideTime = 0;
        // disable progressBar
        clearInterval(this.intervalId);
        this.width = 0;
    }
    /**
     * @return {?}
     */
    delayedHideToast() {
        if (this.options.disableTimeOut ||
            this.options.extendedTimeOut === 0 ||
            this.state.value === 'removed') {
            return;
        }
        this.outsideTimeout(() => this.remove(), this.options.extendedTimeOut);
        this.options.timeOut = this.options.extendedTimeOut;
        this.hideTime = new Date().getTime() + (this.options.timeOut || 0);
        this.width = -1;
        if (this.options.progressBar) {
            this.outsideInterval(() => this.updateProgress(), 10);
        }
    }
    /**
     * @param {?} func
     * @param {?} timeout
     * @return {?}
     */
    outsideTimeout(func, timeout) {
        if (this.ngZone) {
            this.ngZone.runOutsideAngular(() => (this.timeout = setTimeout(() => this.runInsideAngular(func), timeout)));
        }
        else {
            this.timeout = setTimeout(() => func(), timeout);
        }
    }
    /**
     * @param {?} func
     * @param {?} timeout
     * @return {?}
     */
    outsideInterval(func, timeout) {
        if (this.ngZone) {
            this.ngZone.runOutsideAngular(() => (this.intervalId = setInterval(() => this.runInsideAngular(func), timeout)));
        }
        else {
            this.intervalId = setInterval(() => func(), timeout);
        }
    }
    /**
     * @param {?} func
     * @return {?}
     */
    runInsideAngular(func) {
        if (this.ngZone) {
            this.ngZone.run(() => func());
        }
        else {
            func();
        }
    }
}
Toast.decorators = [
    { type: Component, args: [{
                selector: '[toast-component]',
                template: `
  <button *ngIf="options.closeButton" (click)="remove()" class="toast-close-button" aria-label="Close">
    <span aria-hidden="true">&times;</span>
  </button>
  <div *ngIf="title" [class]="options.titleClass" [attr.aria-label]="title">
    {{ title }} <ng-container *ngIf="duplicatesCount">[{{ duplicatesCount + 1 }}]</ng-container>
  </div>
  <div *ngIf="message && options.enableHtml" role="alertdialog" aria-live="polite"
    [class]="options.messageClass" [innerHTML]="message">
  </div>
  <div *ngIf="message && !options.enableHtml" role="alertdialog" aria-live="polite"
    [class]="options.messageClass" [attr.aria-label]="message">
    {{ message }}
  </div>
  <div *ngIf="options.progressBar">
    <div class="toast-progress" [style.width]="width + '%'"></div>
  </div>
  `,
                encapsulation: ViewEncapsulation.None,
                animations: [
                    trigger('flyInOut', [
                        state('inactive', style({ opacity: 0 })),
                        state('active', style({ opacity: 1 })),
                        state('removed', style({ opacity: 0 })),
                        transition('inactive => active', animate('{{ easeTime }}ms {{ easing }}')),
                        transition('active => removed', animate('{{ easeTime }}ms {{ easing }}'))
                    ])
                ],
                preserveWhitespaces: false,
                styles: [".toast-center-center{top:50%;left:50%;transform:translate(-50%,-50%)}.toast-top-center{top:0;right:0;width:100%}.toast-bottom-center{bottom:0;right:0;width:100%}.toast-top-full-width{top:0;right:0;width:100%}.toast-bottom-full-width{bottom:0;right:0;width:100%}.toast-top-left{top:12px;left:12px}.toast-top-right{top:12px;right:12px}.toast-bottom-right{right:12px;bottom:12px}.toast-bottom-left{bottom:12px;left:12px}.toast-title{font-weight:700}.toast-message{word-wrap:break-word}.toast-message a,.toast-message label{color:#fff}.toast-message a:hover{color:#ccc;text-decoration:none}.toast-close-button{position:relative;right:-.3em;top:-.3em;float:right;font-size:20px;font-weight:700;color:#fff;text-shadow:0 1px 0 #fff}.toast-close-button:focus,.toast-close-button:hover{color:#000;text-decoration:none;cursor:pointer;opacity:.4}button.toast-close-button{padding:0;cursor:pointer;background:0 0;border:0}.toast-container{pointer-events:none;position:fixed;z-index:999999}.toast-container *{box-sizing:border-box}.toast-container .ngx-toastr{position:relative;overflow:hidden;margin:0 0 6px;padding:15px 15px 15px 50px;width:300px;border-radius:3px;background-position:15px center;background-repeat:no-repeat;background-size:24px;box-shadow:0 0 12px #999;color:#fff}.toast-container .ngx-toastr:hover{box-shadow:0 0 12px #000;opacity:1;cursor:pointer}.toast-info{background-image:url(\"data:image/svg+xml;charset=utf8,%3Csvg xmlns='http://www.w3.org/2000/svg' viewBox='0 0 512 512' width='512' height='512'%3E%3Cpath fill='rgb(255,255,255)' d='M256 8C119.043 8 8 119.083 8 256c0 136.997 111.043 248 248 248s248-111.003 248-248C504 119.083 392.957 8 256 8zm0 110c23.196 0 42 18.804 42 42s-18.804 42-42 42-42-18.804-42-42 18.804-42 42-42zm56 254c0 6.627-5.373 12-12 12h-88c-6.627 0-12-5.373-12-12v-24c0-6.627 5.373-12 12-12h12v-64h-12c-6.627 0-12-5.373-12-12v-24c0-6.627 5.373-12 12-12h64c6.627 0 12 5.373 12 12v100h12c6.627 0 12 5.373 12 12v24z'/%3E%3C/svg%3E\")}.toast-error{background-image:url(\"data:image/svg+xml;charset=utf8,%3Csvg xmlns='http://www.w3.org/2000/svg' viewBox='0 0 512 512' width='512' height='512'%3E%3Cpath fill='rgb(255,255,255)' d='M256 8C119 8 8 119 8 256s111 248 248 248 248-111 248-248S393 8 256 8zm121.6 313.1c4.7 4.7 4.7 12.3 0 17L338 377.6c-4.7 4.7-12.3 4.7-17 0L256 312l-65.1 65.6c-4.7 4.7-12.3 4.7-17 0L134.4 338c-4.7-4.7-4.7-12.3 0-17l65.6-65-65.6-65.1c-4.7-4.7-4.7-12.3 0-17l39.6-39.6c4.7-4.7 12.3-4.7 17 0l65 65.7 65.1-65.6c4.7-4.7 12.3-4.7 17 0l39.6 39.6c4.7 4.7 4.7 12.3 0 17L312 256l65.6 65.1z'/%3E%3C/svg%3E\")}.toast-success{background-image:url(\"data:image/svg+xml;charset=utf8,%3Csvg xmlns='http://www.w3.org/2000/svg' viewBox='0 0 512 512' width='512' height='512'%3E%3Cpath fill='rgb(255,255,255)' d='M173.898 439.404l-166.4-166.4c-9.997-9.997-9.997-26.206 0-36.204l36.203-36.204c9.997-9.998 26.207-9.998 36.204 0L192 312.69 432.095 72.596c9.997-9.997 26.207-9.997 36.204 0l36.203 36.204c9.997 9.997 9.997 26.206 0 36.204l-294.4 294.401c-9.998 9.997-26.207 9.997-36.204-.001z'/%3E%3C/svg%3E\")}.toast-container.toast-bottom-center .ngx-toastr,.toast-container.toast-top-center .ngx-toastr{width:300px;margin-left:auto;margin-right:auto}.toast-container.toast-bottom-full-width .ngx-toastr,.toast-container.toast-top-full-width .ngx-toastr{width:96%;margin-left:auto;margin-right:auto}.ngx-toastr{background-color:#030303;pointer-events:auto}.toast-success{background-color:#51a351}.toast-error{background-color:#bd362f}.toast-info{background-color:#2f96b4}.toast-warning{background-image:url(\"data:image/svg+xml;charset=utf8,%3Csvg xmlns='http://www.w3.org/2000/svg' viewBox='0 0 576 512' width='576' height='512'%3E%3Cpath fill='rgb(255,255,255)' d='M569.517 440.013C587.975 472.007 564.806 512 527.94 512H48.054c-36.937 0-59.999-40.055-41.577-71.987L246.423 23.985c18.467-32.009 64.72-31.951 83.154 0l239.94 416.028zM288 354c-25.405 0-46 20.595-46 46s20.595 46 46 46 46-20.595 46-46-20.595-46-46-46zm-43.673-165.346l7.418 136c.347 6.364 5.609 11.346 11.982 11.346h48.546c6.373 0 11.635-4.982 11.982-11.346l7.418-136c.375-6.874-5.098-12.654-11.982-12.654h-63.383c-6.884 0-12.356 5.78-11.981 12.654z'/%3E%3C/svg%3E\");background-color:#f89406}.toast-progress{position:absolute;left:0;bottom:0;height:4px;background-color:#000;opacity:.4}@media all and (max-width:240px){.toast-container .ngx-toastr.div{padding:8px 8px 8px 50px;width:11em}.toast-container .toast-close-button{right:-.2em;top:-.2em}}@media all and (min-width:241px) and (max-width:480px){.toast-container .ngx-toastr.div{padding:8px 8px 8px 50px;width:18em}.toast-container .toast-close-button{right:-.2em;top:-.2em}}@media all and (min-width:481px) and (max-width:768px){.toast-container .ngx-toastr.div{padding:15px 15px 15px 50px;width:25em}}"]
            }] }
];
/** @nocollapse */
Toast.ctorParameters = () => [
    { type: ToastrService },
    { type: ToastPackage },
    { type: NgZone }
];
Toast.propDecorators = {
    toastClasses: [{ type: HostBinding, args: ['class',] }],
    state: [{ type: HostBinding, args: ['@flyInOut',] }],
    displayStyle: [{ type: HostBinding, args: ['style.display',] }],
    tapToast: [{ type: HostListener, args: ['click',] }],
    stickAround: [{ type: HostListener, args: ['mouseenter',] }],
    delayedHideToast: [{ type: HostListener, args: ['mouseleave',] }]
};

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,uselessCode} checked by tsc
 */
/** @type {?} */
const DefaultGlobalConfig = Object.assign({}, DefaultNoComponentGlobalConfig, { toastComponent: Toast });
class ToastrModule {
    /**
     * @param {?=} config
     * @return {?}
     */
    static forRoot(config = {}) {
        return {
            ngModule: ToastrModule,
            providers: [
                {
                    provide: TOAST_CONFIG,
                    useValue: {
                        default: DefaultGlobalConfig,
                        config,
                    },
                },
            ],
        };
    }
}
ToastrModule.decorators = [
    { type: NgModule, args: [{
                imports: [CommonModule],
                declarations: [Toast],
                exports: [Toast],
                entryComponents: [Toast]
            },] }
];

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,uselessCode} checked by tsc
 */
// import {ToastContainerModule} from './layout/components/toastr/toast.directive';
// import {ToastNoAnimationModule} from './layout/components/toastr/toast-noanimation.component';
// import {ToastrService} from './layout/components/toastr/toastr.service';
// import {BrowserAnimationsModule} from '@angular/platform-browser/animations';
// import {BrowserModule} from '@angular/platform-browser';
library.add(fas);
// library.add(far);
class AngularComponentsModule {
}
AngularComponentsModule.decorators = [
    { type: NgModule, args: [{
                declarations: [
                    // LayoutComponents
                    AlertComponent,
                    ButtonComponent,
                    IconComponent,
                    ListComponent,
                    LoadingComponent,
                    MenuComponent,
                    PageHeaderComponent,
                    // FormComponents
                    FieldErrorComponent,
                    InputTextComponent,
                    InputSelectComponent,
                    SubmitComponent,
                    ToastComponent
                ],
                imports: [
                    CommonModule,
                    // BrowserModule,
                    // BrowserAnimationsModule,
                    FormsModule,
                    ReactiveFormsModule,
                    FontAwesomeModule,
                    DragDropModule,
                    TabsetModule,
                    TooltipModule,
                    ModalModule,
                    ToastrModule.forRoot()
                ],
                exports: [
                    // LayoutComponents
                    AlertComponent,
                    ButtonComponent,
                    IconComponent,
                    ListComponent,
                    LoadingComponent,
                    PageHeaderComponent,
                    MenuComponent,
                    TabsetModule,
                    TooltipModule,
                    ModalModule,
                    ToastrModule,
                    // ToastContainerModule,
                    // ToastNoAnimationModule,
                    // FormComponents
                    FieldErrorComponent,
                    InputTextComponent,
                    InputSelectComponent,
                    SubmitComponent,
                    ToastComponent,
                ]
            },] }
];

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,uselessCode} checked by tsc
 */

export { IconComponent, ModalComponent, ListComponent, AngularComponentsModule, FieldErrorComponent as ɵk, InputSelectComponent as ɵn, InputTextComponent as ɵm, SubmitComponent as ɵo, FieldErrorService as ɵl, AlertComponent as ɵf, ButtonComponent as ɵg, LoadingComponent as ɵh, MenuComponent as ɵi, NgbModal as ɵa, NgbModalBackdrop as ɵbc, NgbModalConfig as ɵd, NgbModalStack as ɵb, NgbModalWindow as ɵbd, ModalModule as ɵbb, Overlay as ɵbl, OverlayContainer as ɵbm, OverlayRef as ɵbo, PageHeaderComponent as ɵj, BasePortalHost as ɵbp, Tab as ɵu, TabContent as ɵt, TabTitle as ɵs, Tabset as ɵv, TabsetConfig as ɵw, TabsetModule as ɵr, ToastEventService as ɵq, ToastComponent as ɵp, ToastRef as ɵbn, Toast as ɵbg, TOAST_CONFIG as ɵbk, ToastPackage as ɵbi, DefaultGlobalConfig as ɵbe, ToastrModule as ɵbf, ToastrService as ɵbh, TooltipConfig as ɵy, TooltipDirective as ɵba, TooltipWindowComponent as ɵz, TooltipModule as ɵx, BooleanInput as ɵe, ScrollBar as ɵc };

//# sourceMappingURL=penkz-angular-components.js.map