import { EventEmitter, Injector, OnInit } from '@angular/core';
import { ControlValueAccessor, FormControl, NgControl } from '@angular/forms';
import { IconProp, SizeProp } from '@fortawesome/fontawesome-svg-core';
import { TooltipClass } from '../../../layout/components/tooltip/tooltip.class.type';
import { PlacementArray } from '../../../utils/positioning';
import { ButtonStyles } from '../../../layout/components/button/button.types';
import { InputType } from './input-type';
import { FormType } from '../../../types/form-type';
export declare class InputTextComponent implements ControlValueAccessor, OnInit {
    protected injector: Injector;
    append: string;
    appendIcon: IconProp;
    appendClass: ButtonStyles;
    appendTooltip: string;
    autoComplete: string;
    class: string;
    disabled: boolean;
    formType: FormType;
    formControl: FormControl;
    iconSize: SizeProp;
    label: string;
    margin: boolean;
    maskText: string;
    placeholder: string;
    prepend: string;
    prependClass: ButtonStyles;
    prependIcon: IconProp;
    prependIconSmall: boolean;
    readonly: boolean;
    rows: number;
    showValue: boolean;
    showValidation: boolean;
    text: string;
    tooltip: string;
    tooltipClass: TooltipClass;
    tooltipPosition: PlacementArray;
    type: InputType;
    uppercase: boolean;
    appendClick: EventEmitter<{}>;
    prependClick: EventEmitter<{}>;
    model: any;
    private _disabled;
    _formControl: any;
    onChange: any;
    onTouched: any;
    ngControl: NgControl;
    constructor(injector: Injector);
    ngOnInit(): void;
    change(): void;
    registerOnChange(fn: any): void;
    registerOnTouched(fn: any): void;
    setDisabledState(isDisabled: boolean): void;
    writeValue(obj: any): void;
    appendClicked(event: any): void;
    prependClicked(event: any): void;
}
