import { PlacementArray } from '../../../utils/positioning';
import { TooltipClass } from './tooltip.class.type';
/**
 * A configuration service for the [`TooltipDirective`](#/components/tooltip/api#TooltipDirective) component.
 *
 * You can inject this service, typically in your root component, and customize the values of its properties in
 * order to provide default values for all the tooltips used in the application.
 */
export declare class TooltipConfig {
    autoClose: boolean | 'inside' | 'outside';
    placement: PlacementArray;
    triggers: string;
    container: string;
    disableTooltip: boolean;
    tooltipClass: TooltipClass;
    openDelay: number;
    closeDelay: number;
}
